#include "F021_F2837xD_C28x.h"
#include "app_update.h"
#include "scia_device.h"

#ifdef _USE_WATCHDOG
#include "watchdog_device.h"
#endif
#include "F28x_Project.h"

#define UPDATE_STACK_SIZE  128U
static StaticTask_t upDateTaskBuffer;
static StackType_t  upDateTaskStack[UPDATE_STACK_SIZE];


int Renew_UpdataFlag(uint16_t p)
{
    int sStatus;

    Fapi_StatusType oReturnCheck;
    volatile Fapi_FlashStatusType oFlashStatus;

    sStatus = STATUS_OK;

    // Gain pump semaphore
    SeizeFlashPump();
    EALLOW;
    Flash0EccRegs.ECC_ENABLE.bit.ENABLE = 0x0;
    EDIS;
    EALLOW;
    oReturnCheck = Fapi_initializeAPI(F021_CPU0_BASE_ADDRESS, CPUCLK_FREQUENCY);//for now keeping it out
    if(oReturnCheck != Fapi_Status_Success)
        {
        // Check Flash API documentation for possible errors
        sStatus = 1;
        }
    oReturnCheck = Fapi_setActiveFlashBank(Fapi_FlashBank0);
    if(oReturnCheck != Fapi_Status_Success)
        {
        // Check Flash API documentation for possible errors
        sStatus = 2;
        }
    oReturnCheck = Fapi_issueAsyncCommandWithAddress(Fapi_EraseSector,(uint32 *)ENTRYADDR_N);
    while (Fapi_checkFsmForReady() != Fapi_Status_FsmReady){sStatus = 3;}

    oReturnCheck = Fapi_issueProgrammingCommand((uint32 *)ENTRYADDR_N,&p,4,0,0,Fapi_AutoEccGeneration);
    while(Fapi_checkFsmForReady() == Fapi_Status_FsmBusy);
    if(oReturnCheck != Fapi_Status_Success)
    {
    // Check Flash API documentation for possible errors
        sStatus = 3;
    }
    oFlashStatus = Fapi_getFsmStatus();

    ReleaseFlashPump(); // Leave control over flash pump

    return sStatus;
}

uint16_t dt[256];
void vUpdateTask(void * pvParameters)
{
    uint16_t ln;
	uint16 usStatus;
	uswatchdogTaskMask |= WD_TASK_MASK_UPDATE;
    for(;;)
        {
        #ifdef _USE_WATCHDOG
            //watchdog marsk
            //uswatchdogTaskMask |= WD_TASK_MASK_UPDATE;
        #endif

        ln = usSciaBlockRead(dt, (20 / portTICK_PERIOD_MS));
       if(ln > 0)
       		{
             if((dt[1]==0xA5)&&(dt[2]==0xA5))//
                {
                    usStatus = Renew_UpdataFlag(APP_UPDATE_NEEDED);
                    if(usStatus == STATUS_OK)
                    {
                       uswatchdogTaskMask &= !WD_TASK_MASK_UPDATE;
                    }                  
                }
       		}

        }
}




void vUpdateTaskInit(void)
{

    // Create the task without using any dynamic memory allocation.

    xTaskCreateStatic(vUpdateTask,              // Function that implements the task.
                      "Update task",            // Text name for the task.
                      UPDATE_STACK_SIZE,        // Number of indexes in the xStack array.
                      ( void * ) NULL,          // Parameter passed into the task.
                      tskIDLE_PRIORITY + 2,     // Priority at which the task is created.
                      upDateTaskStack,          // Array to use as the task's stack.
                      &upDateTaskBuffer );      // Variable to hold the task's data structure.

}

//
// End of file
//
