
#include "innerdata_renew.h"
#include "innerdata_rtudev.h"
#include "scib_device.h"
#include "spi_device.h"
#include "gpio_device.h"

#ifdef _USE_WATCHDOG
#include "watchdog_device.h"
#endif
#include "F28x_Project.h"

#define INNERDATA_STACK_SIZE  256U
static StaticTask_t InnerdataTaskBuffer;
static StackType_t  InnerdataTaskStack[INNERDATA_STACK_SIZE];

extern rtuDev  *gRtuDevs[];
extern sci_para_dt scib_para;


//uint16_t dt1[256];
uint16_t ARM_RUN_FLAG;

void vInnerdataRefTask(void * pvParameters)
{
//	uint16_t ln;
//	uint16_t usStatus;
	uint16_t crc16;
	rtuDev *rtu_dev;
	uint16_t count = 0;
	ARM_RUN_FLAG = 0;

	rtu_devs_init();
	//vTaskDelay(2000 / portTICK_PERIOD_MS);//200->1S 20->0.1S
	ARM_RESET_DISABLE;
    for(;;)
        {
        #ifdef _USE_WATCHDOG
            //watchdog marsk
            uswatchdogTaskMask |= WD_TASK_MASK_SCIB;
        #endif

		count++;
		if(count > 100)
			{
			//while(ARM_RUN_STATES == 1);	//ARMõ͵ƽ
			ARM_RUN_FLAG = 1;
			}
			
       scib_para.usRx_lenth = usScibBlockRead(scib_para.ucRx_buffer, (20 / portTICK_PERIOD_MS));
       if(scib_para.usRx_lenth > 2)
       		{
			//
			//vSpic_xframe(scib_para.ucRx_buffer,scib_para.usRx_lenth);
            //sScibBlockWrite(dt1, ln, (20 / portTICK_PERIOD_MS));   

			crc16 = mb_crc16(scib_para.ucRx_buffer,scib_para.usRx_lenth-2);
			if((scib_para.ucRx_buffer[scib_para.usRx_lenth-2] + scib_para.ucRx_buffer[scib_para.usRx_lenth-1]*256) != crc16)
				continue;

			rtu_dev = gRtuDevs[scib_para.ucRx_buffer[0]];
			if( rtu_dev == NULL )	
				continue;

			rtu_dev->devDealTcpDT(scib_para.ucRx_buffer,scib_para.usRx_lenth, rtu_dev );
			if( scib_para.usTx_lenth > 0 )
				{
					sScibBlockWrite(scib_para.ucTx_buffer, scib_para.usTx_lenth, (20 / portTICK_PERIOD_MS));
				}
       		}

        }
}

void vInnerdataRefTaskInit(void)
{
xTaskCreateStatic(vInnerdataRefTask,				// Function that implements the task.
				  "InnerdataRef task",			// Text name for the task.
				  INNERDATA_STACK_SIZE,		// Number of indexes in the xStack array.
				  ( void * ) NULL,			// Parameter passed into the task.
				  tskIDLE_PRIORITY + 2, 	// Priority at which the task is created.
				  InnerdataTaskStack,			// Array to use as the task's stack.
				  &InnerdataTaskBuffer );		// Variable to hold the task's data structure.

}

//
// End of file
//

