#include "innerdata_rtudev.h"
#include "routing.h"

extern Sys_dt_t rout_data;
//extern sci_para_dt scib_para;

rtuDev  *gRtuDevs[rtuDev_num];
sci_para_dt scib_para;

rtuDev rtu_inst_data_dev;
rtuDev rtu_value1_data_dev;
rtuDev rtu_value2_data_dev;
rtuDev rtu_set_para_dev;
rtuDev rtu_calib_para_dev;
rtuDev rtu_debug_para_dev;

//==============================================================================
// App: Modbus_change_order_bytes()
//==============================================================================

static void Modbus_change_order_words(uint16_t *buf,char *  _pBuff,
                                      int _dataLen,uint8_t flag)
{
	int i;

	for ( i = 0; i < _dataLen; i++)
	{
		buf[i] = _pBuff[i*2] + _pBuff[i*2+1]*256;
	}

	
/*	if(flag == 5)
	{		
		if(_dataLen%2 !=0)
		j = _dataLen+1;
	 	else
	 	   j = _dataLen;

		for ( i = 0; i < j; i+=2)
		{
			swop = buf[i];
			buf[i] = buf[i+1];
			buf[i+1] = swop;
		}			
	}*/
 	
}



static void Modbus_change_order_bytes(uint16_t *buf,char *  _pBuff,
                                      int _dataLen,uint8_t flag)
{
	uint16_t swop;
	int i,j;
	if((flag == 2)||(flag == 2)||(flag == 5))
	{
		if(_dataLen%2 !=0)
		j = _dataLen+1;
	 	else
	 	   j = _dataLen;

		for ( i = 0; i < j; i+=2)
		{
			swop = buf[i];
			buf[i] = buf[i+1];
			buf[i+1] = swop;
		}			
	}
 	
	
    for ( i = 0; i < _dataLen; i++)
	{
      	_pBuff[i*2] = (buf[i]>>8)&0xff;
		_pBuff[i*2+1] = buf[i]&0xff;
    };
}

uint16_t mb_crc16(uint8_t *data, unsigned short len)
{
	uint16_t CRC11;
	uint16_t Temp;
    uint32_t IX,IY;
    
	CRC11=0xFFFF;

    if(len==0)
		return CRC11;
	
	for(IX=0; IX<len; IX++)
    {
		Temp = (CRC11&0x00FF)^data[IX];
		CRC11 = (CRC11&0xFF00)+Temp;
		for(IY=0; IY<8; IY++)
			if ((CRC11&1)!=0)
				CRC11=(CRC11>>1)^0xA001;
			else
				CRC11=CRC11>>1;
    }

	return CRC11;
}

uint16_t  ch_buf[256];
int devs_deal_tcp_data( uint8_t *ch, unsigned short len, void  *rs_Dev )
	{
	rtuDev *rsDev;
	uint32_t sAddr;
	unsigned short num;
	uint16_t  crc16;
	

	rsDev = (rtuDev *)rs_Dev;

	switch ( ch[1] )
	{
	case 0x03:
		if( len != 8 )
			{   
			ch[1] += 0x80;
			ch[2] = 0x02;
			num = 4;
			break;
			}
		sAddr = (ch[2] * 256 + ch[3]);

		if((ch[5] < 1) || (126 < ch[5] ))
			{   /* ݳȳΧ */
			ch[1] += 0x80;
			ch[2] = 0x02;
			num = 4;
			break;
			}
		
		num = ch[5] ;
		if( (sAddr + num) > rsDev->dev_rdt_num )
			{   
			
			ch[1] += 0x80;
			ch[2] = 0x03;
			num = 4;	//λ
			break;
			}
	
		ch[2] = num *2;
		
		memcpy(ch_buf, (rsDev->pDevData + sAddr ), num);
		
		Modbus_change_order_bytes(ch_buf,(ch+3),  num ,ch[0]);//01 float Ҫ
		
		num = ch[2]+3;
		break;
		
	case 0x10:
		sAddr = (ch[2] * 256 + ch[3]);	
		num = ch[5];
		if( ( (sAddr + num)  > rsDev->dev_wdt_num) || (rsDev->dt_write_enable == 0))
			{   /*Ƿλ*/
			ch[1] += 0x80;
			ch[2] = 0x02;
			return 3;
			}
		Modbus_change_order_words(ch_buf, (ch+7) , num ,ch[0]);	
		
		memcpy( (rsDev->pDevData + sAddr ),ch_buf, num);	//(ch+7)	
		
		num = 6;
		break;
		
	default:
		
		ch[1] += 0x80;
		ch[2] = 0x01;
		num = 4;
		break;

	}
	
	memcpy(scib_para.ucTx_buffer,ch,num);	
	crc16 = mb_crc16(scib_para.ucTx_buffer,num);
	scib_para.usTx_lenth = num + 2;
	
	scib_para.ucTx_buffer[scib_para.usTx_lenth - 2] = crc16&0xff;
	scib_para.ucTx_buffer[scib_para.usTx_lenth - 1] = (crc16>>8)&0xff;
	
	return scib_para.usTx_lenth;
}


void rtu_devs_init(void)
{
	gRtuDevs[0] = 0;
	gRtuDevs[RTU_INST_DATA_DEV_ADDR] = &rtu_inst_data_dev;
	gRtuDevs[RTU_VALUE1_DATA_DEV_ADDR] = &rtu_value1_data_dev;
	gRtuDevs[RTU_VALUE2_DATA_DEV_ADDR] = &rtu_value2_data_dev;
	gRtuDevs[RTU_SET_PARA_DEV_ADDR] = &rtu_set_para_dev;
	gRtuDevs[RTU_CALIB_PARA_DEV_ADDR] = &rtu_calib_para_dev;
	gRtuDevs[RTU_DEBUG_PARA_ADDR] = &rtu_debug_para_dev;
	gRtuDevs[7] = 0;

	
	rtu_inst_data_dev.devDealTcpDT = devs_deal_tcp_data;
	rtu_inst_data_dev.devProRx = NULL;
	rtu_inst_data_dev.devProTx = NULL;
	rtu_inst_data_dev.dev_addr = RTU_INST_DATA_DEV_ADDR;
	rtu_inst_data_dev.dev_rdt_num = sizeof(Real_Inst_dt);
	rtu_inst_data_dev.dev_wdt_num = sizeof(Real_Inst_dt);
	rtu_inst_data_dev.pDevData = (char *)(&rout_data.Inst_data);
	rtu_inst_data_dev.dt_write_enable = 0;
	

	rtu_value1_data_dev.devDealTcpDT = devs_deal_tcp_data;
	rtu_value1_data_dev.devProRx = NULL;
	rtu_value1_data_dev.devProTx = NULL;
	rtu_value1_data_dev.dev_addr = RTU_VALUE1_DATA_DEV_ADDR;
	rtu_value1_data_dev.dev_rdt_num = sizeof(Real_Value1_dt);
	rtu_value1_data_dev.dev_wdt_num = sizeof(Real_Value1_dt);
	rtu_value1_data_dev.pDevData = (char *)(&rout_data.Value1_data);
	rtu_value1_data_dev.dt_write_enable = 0;

	rtu_value2_data_dev.devDealTcpDT = devs_deal_tcp_data;
	rtu_value2_data_dev.devProRx = NULL;
	rtu_value2_data_dev.devProTx = NULL;
	rtu_value2_data_dev.dev_addr = RTU_VALUE2_DATA_DEV_ADDR;
	rtu_value2_data_dev.dev_rdt_num = sizeof(Real_Value2_dt);
	rtu_value2_data_dev.dev_wdt_num = sizeof(Real_Value2_dt);
	rtu_value2_data_dev.pDevData = (char *)(&rout_data.Value2_data);
	rtu_value2_data_dev.dt_write_enable = 0;

	rtu_set_para_dev.devDealTcpDT = devs_deal_tcp_data;
	rtu_set_para_dev.devProRx = NULL;
	rtu_set_para_dev.devProTx = NULL;
	rtu_set_para_dev.dev_addr = RTU_SET_PARA_DEV_ADDR;
	rtu_set_para_dev.dev_rdt_num = sizeof(Set_Para_dt);
	rtu_set_para_dev.dev_wdt_num = sizeof(Set_Para_dt);
	rtu_set_para_dev.pDevData = (char *)(&rout_data.Set_Para);
	rtu_set_para_dev.dt_write_enable = 1;
	
	rtu_calib_para_dev.devDealTcpDT = devs_deal_tcp_data;
	rtu_calib_para_dev.devProRx = NULL;
	rtu_calib_para_dev.devProTx = NULL;
	rtu_calib_para_dev.dev_addr = RTU_CALIB_PARA_DEV_ADDR;
	rtu_calib_para_dev.dev_rdt_num = sizeof(Calib_Para_dt);
	rtu_calib_para_dev.dev_wdt_num = sizeof(Calib_Para_dt);
	rtu_calib_para_dev.pDevData = (char *)(&rout_data.Calib_Para);
	rtu_calib_para_dev.dt_write_enable = 1;

	rtu_debug_para_dev.devDealTcpDT = devs_deal_tcp_data;
	rtu_debug_para_dev.devProRx = NULL;
	rtu_debug_para_dev.devProTx = NULL;
	rtu_debug_para_dev.dev_addr = RTU_DEBUG_PARA_ADDR;
	rtu_debug_para_dev.dev_rdt_num = sizeof(Debug_Para_dt);
	rtu_debug_para_dev.dev_wdt_num = sizeof(Debug_Para_dt);
	rtu_debug_para_dev.pDevData = (char *)(&rout_data.Debug_Para);
	rtu_debug_para_dev.dt_write_enable = 1;

}


