#ifndef __INNER_RTUDEV_H__
#define __INNER_RTUDEV_H__

#include "sys_config.h"
#include "FreeRTOS.h"
#include "task.h"


#define RTU_INST_DATA_DEV_ADDR		1
#define RTU_VALUE1_DATA_DEV_ADDR	2	
#define RTU_VALUE2_DATA_DEV_ADDR	3
#define RTU_SET_PARA_DEV_ADDR		4
#define RTU_CALIB_PARA_DEV_ADDR		5
#define RTU_DEBUG_PARA_ADDR			6
#define rtuDev_num 8

typedef int (*dev_deal_tcp_data)( uint8_t *ch, unsigned short len ,void  *rs_Dev);
typedef int (*dev_pro_rx)(void *RSPort); 
typedef int (*dev_pro_tx)(void  *RSPort); 


#define BUFF_NUM_MAX 256
typedef struct
{
    uint8_t ucRx_buffer[BUFF_NUM_MAX];
    unsigned short usRx_lenth;
    char cRx_status;

    uint8_t ucTx_buffer[BUFF_NUM_MAX];
    unsigned short usTx_lenth;
    char cTx_status;

    uint8_t ucIdle_status;
}sci_para_dt;


typedef struct
{	/*dev config*/
	unsigned int dev_addr;
	/*dev functions*/
	dev_pro_rx  devProRx;
	dev_pro_tx  devProTx;
	dev_deal_tcp_data devDealTcpDT;
	char *pDevData;
	int dev_rdt_num;
	int dev_wdt_num;
	int dt_write_enable; /* 1 enable; 0 disable */
}rtuDev;

void rtu_devs_init(void);
uint16_t mb_crc16(uint8_t *data, unsigned short len);




#endif /*  __RTUDEV_H__ */
