//#############################################################################
//
// FILE:   main.c
//
// TITLE:  demon Example
//
//
//#############################################################################
//
//
// $Copyright:
//
//#############################################################################

//
// Included Files
//

#include "device.h"

#include "F28x_Project.h"     // Device Headerfile and Examples Include File
#include "FreeRTOS.h"
#include "task.h"
#include "heartbeat.h"
#include "app_update.h"
#include "innerdata_renew.h"

#include "routing.h"
#include "main_math.h"
#include "sysmanage.h"


const char SoftVersion[16] = "V0.2.0.1219";
#pragma DATA_SECTION(SoftVersion,"AppVer")
#pragma RETAIN(SoftVersion)
//
// Main
//
void main(void)
{
    //
    // Initialize device clock and peripherals
    //
    Device_init();

#ifdef _STANDALONE
#ifdef _FLASH
    //
    // Send boot command to allow the CPU2 application to begin execution
    //
    Device_bootCPU2(C1C2_BROM_BOOTMODE_BOOT_FROM_FLASH);
#else
    //
    // Send boot command to allow the CPU2 application to begin execution
    //
    Device_bootCPU2(C1C2_BROM_BOOTMODE_BOOT_FROM_RAM);

#endif // _FLASH
#endif // _STANDALONE

	//Applications Init
	vRoutine_init();
	vGobalVariablesInit();


    //Applications Task Init
    vheartBeatTaskInit();
	vUpdateTaskInit();
	vInnerdataRefTaskInit();
	vsysManageTaskInit();

    // Start Task Scheduler
    vTaskStartScheduler();

}

//
// End of File
//
