
#include "main_math.h"
#include "pwm_device.h"




ABC_DQ0_POS vGrid_dq0_pos;
ABC_DQ0_POS vGrid_dq0_pos_filter;
ABC_DQ0_NEG vGrid_dq0_neg;
ABC_DQ0_POS iInv_dq0_pos;
ABC_DQ0_POS iInv_dq0_pos_filter;
ABC_DQ0_POS iGrid_dq0_pos;
DQ0_ABC vInv_dq0;
DQ0_ABC vInv_dq0_ref;
SPLL_3PH_DDSRF  spll_3ph_1;

POWER_MEAS_SINE_ANALYZER SYS_sine_mains_A;
POWER_MEAS_SINE_ANALYZER SYS_sine_mains_B;
POWER_MEAS_SINE_ANALYZER SYS_sine_mains_C;

POWER_MEAS_SINE_ANALYZER LOAD_sine_mains_A;
POWER_MEAS_SINE_ANALYZER LOAD_sine_mains_B;
POWER_MEAS_SINE_ANALYZER LOAD_sine_mains_C;

SPLL_3PH_DQ spll_3ph;

DCL_PI dcl_gi_id = PI_DEFAULTS;
DCL_PI dcl_gi_iq = PI_DEFAULTS;
DCL_PI dcl_gi_iz = PI_DEFAULTS;
DCL_PI dcl_gv_vBus = PI_DEFAULTS;
DCL_PI dcl_gv_vBanlence = PI_DEFAULTS;

float32_t dcl_gi_id_out;
float32_t dcl_gi_iq_out;
float32_t dcl_gi_iz_out;
float32_t dcl_gv_vBus_out;
float32_t dcl_gv_vBanlence_out;


volatile float32_t dcl_idRef;
volatile float32_t dcl_iqRef;
volatile float32_t dcl_vBusRef;
volatile float32_t dcl_vBusRefSlewed;
float32_t dcl_vdInv;
float32_t dcl_vqInv;
float32_t dcl_vzInv;
volatile int32_t ctl_closeGiLoop;
volatile int32_t ctl_closeGvLoop;
volatile int32_t ctl_pll_ref;

#pragma CODE_SECTION(vSequenceSep,".TI.ramfunc");
#pragma CODE_SECTION(vRunVoltageLoop2,".TI.ramfunc");
#pragma CODE_SECTION(vRunCurrentLoop2,".TI.ramfunc");



void vGobalVariablesInit(void)
{
  
    ABC_DQ0_POS_reset(&iInv_dq0_pos);
	ABC_DQ0_POS_reset(&iInv_dq0_pos_filter);
    ABC_DQ0_POS_reset(&iGrid_dq0_pos);
    ABC_DQ0_POS_reset(&vGrid_dq0_pos);
	ABC_DQ0_POS_reset(&vGrid_dq0_pos_filter);
    ABC_DQ0_NEG_reset(&vGrid_dq0_neg);

    DQ0_ABC_reset(&vInv_dq0);
	DQ0_ABC_reset(&vInv_dq0_ref);

    //
    // SPLL initialization
    // 

/*    SPLL_3PH_DDSRF_init( AC_FREQ_HZ,
                        (float32_t)(1.0 / CONF_PWM_SWITCHING_FREQ_HZ),
                        (float32_t)(0.00188141f),
                        (float32_t)(-0.99623717f),
                        &spll_3ph_1);

     spll_3ph_1.lpf_coeff.b0 = 333.807f;
     spll_3ph_1.lpf_coeff.b1 = -333.674f;*/

	 SPLL_3PH_DQ_init(&spll_3ph);


	 POWER_MEAS_SINE_ANALYZER_reset(&SYS_sine_mains_A);
	 POWER_MEAS_SINE_ANALYZER_config(&SYS_sine_mains_A,
									 ISR2_FREQUENCY_HZ,
									 (float32_t)0.05f,
									 (float32_t)UNIVERSAL_GRID_MAX_FREQ,
									 (float32_t)UNIVERSAL_GRID_MIN_FREQ);
	 POWER_MEAS_SINE_ANALYZER_reset(&SYS_sine_mains_B);
	 POWER_MEAS_SINE_ANALYZER_config(&SYS_sine_mains_B,
									 ISR2_FREQUENCY_HZ,
									 (float32_t)0.05f,
									 (float32_t)UNIVERSAL_GRID_MAX_FREQ,
									 (float32_t)UNIVERSAL_GRID_MIN_FREQ);
	 POWER_MEAS_SINE_ANALYZER_reset(&SYS_sine_mains_C);
	 POWER_MEAS_SINE_ANALYZER_config(&SYS_sine_mains_C,
									 ISR2_FREQUENCY_HZ,
									 (float32_t)0.05f,
									 (float32_t)UNIVERSAL_GRID_MAX_FREQ,
									 (float32_t)UNIVERSAL_GRID_MIN_FREQ);


	POWER_MEAS_SINE_ANALYZER_reset(&LOAD_sine_mains_A);
	 POWER_MEAS_SINE_ANALYZER_config(&LOAD_sine_mains_A,
									 ISR2_FREQUENCY_HZ,
									 (float32_t)0.05f,
									 (float32_t)UNIVERSAL_GRID_MAX_FREQ,
									 (float32_t)UNIVERSAL_GRID_MIN_FREQ);
	 POWER_MEAS_SINE_ANALYZER_reset(&LOAD_sine_mains_B);
	 POWER_MEAS_SINE_ANALYZER_config(&LOAD_sine_mains_B,
									 ISR2_FREQUENCY_HZ,
									 (float32_t)0.05f,
									 (float32_t)UNIVERSAL_GRID_MAX_FREQ,
									 (float32_t)UNIVERSAL_GRID_MIN_FREQ);
	 POWER_MEAS_SINE_ANALYZER_reset(&LOAD_sine_mains_C);
	 POWER_MEAS_SINE_ANALYZER_config(&LOAD_sine_mains_C,
									 ISR2_FREQUENCY_HZ,
									 (float32_t)0.05f,
									 (float32_t)UNIVERSAL_GRID_MAX_FREQ,
									 (float32_t)UNIVERSAL_GRID_MIN_FREQ);			

	dcl_vdInv = 0.0f;
    dcl_vqInv = 0.0f;
    dcl_vzInv = 0.0f;
	dcl_idRef = 0.0f;
    dcl_iqRef = 0.0f;

	dcl_gi_id.Umax = 500;
	dcl_gi_id.Umin = -500;

	dcl_gi_iq.Umax = 500;
	dcl_gi_iq.Umin = -500;

	dcl_gi_iz.Umax = 500;
	dcl_gi_iz.Umin = -500;

	dcl_gv_vBus.Umax = 50;
	dcl_gv_vBus.Umin = -50;

	dcl_gv_vBanlence.Umax = 10;
	dcl_gv_vBanlence.Umin = -10;

}





#define RATED_GIRD_FREQUENCY   ((float)50)    // Unit, Hz
#define VALUE_2PI   ((float)6.283185307)    //2*PI
#define PWM_FREQ    ((float)20000)          //(16000)
#define TS    ((float)1.0/PWM_FREQ)         //sample time
#define DWT_FIRST  (float)(VALUE_2PI * RATED_GIRD_FREQUENCY)
#define PI					((float)3.1415927)



extern float32_t fSine,fCose;
extern float32_t fSine2,fCose2;
#pragma CODE_SECTION(vSequenceSep,".TI.ramfunc");
volatile void vSequenceSep(void)
{
	float D_P_Temp,Q_P_Temp,D_N_Temp,Q_N_Temp;
	float fLPFTemp;
	//vGrid_dq0_pos.alpha
	fLPFTemp = 45.0f*0.000314f;

	CurrCtrlObject.nPosUd = vGrid_dq0_pos.d;
	CurrCtrlObject.nPosUq = vGrid_dq0_pos.q;

	CurrCtrlObject.nNegUd = vGrid_dq0_pos.alpha * fCose - vGrid_dq0_pos.beta * fSine;
	CurrCtrlObject.nNegUq = vGrid_dq0_pos.alpha * fSine + vGrid_dq0_pos.beta * fCose;

	D_P_Temp = CurrCtrlObject.nNegUdFilter * fCose2 + CurrCtrlObject.nNegUqFilter * fSine2;
    Q_P_Temp = CurrCtrlObject.nNegUdFilter * fSine2 - CurrCtrlObject.nNegUqFilter * fCose2;    
    D_N_Temp = CurrCtrlObject.nPosUdFilter * fCose2 - CurrCtrlObject.nPosUqFilter * fSine2;
    Q_N_Temp = CurrCtrlObject.nPosUdFilter * fSine2 + CurrCtrlObject.nPosUqFilter * fCose2;

	CurrCtrlObject.nPosUd = CurrCtrlObject.nPosUd - D_P_Temp;
    CurrCtrlObject.nPosUq = CurrCtrlObject.nPosUq + Q_P_Temp;
    
    CurrCtrlObject.nNegUd = CurrCtrlObject.nNegUd - D_N_Temp;
    CurrCtrlObject.nNegUq = CurrCtrlObject.nNegUq - Q_N_Temp;

	//LIMIT(CurrCtrlObject.nPosUd, 470, 0);
	//LIMIT(CurrCtrlObject.nPosUq, 20, -20);
	//LIMIT(CurrCtrlObject.nNegUd, 69, -136);
	//LIMIT(CurrCtrlObject.nNegUq, 120, -120);

//	FILTER1(CurrCtrlObject.nPosUdFilter,CurrCtrlObject.nPosUd,45,fLPFTemp);	//ܿȻϵͳͣλ
//	FILTER1(CurrCtrlObject.nPosUqFilter,CurrCtrlObject.nPosUq,45,fLPFTemp);
//	FILTER1(CurrCtrlObject.nNegUdFilter,CurrCtrlObject.nNegUd,45,fLPFTemp);
//	FILTER1(CurrCtrlObject.nNegUqFilter,CurrCtrlObject.nNegUq,45,fLPFTemp);
//	CurrCtrlObject.nPosUdFilter = (1.0f - fLPFTemp)*CurrCtrlObject.nPosUdFilter + fLPFTemp * CurrCtrlObject.nPosUd;
//	CurrCtrlObject.nPosUqFilter = (1.0f - fLPFTemp)*CurrCtrlObject.nPosUqFilter + fLPFTemp * CurrCtrlObject.nPosUq;
//	CurrCtrlObject.nNegUdFilter = (1.0f - fLPFTemp)*CurrCtrlObject.nNegUdFilter + fLPFTemp * CurrCtrlObject.nNegUd;
//	CurrCtrlObject.nNegUqFilter = (1.0f - fLPFTemp)*CurrCtrlObject.nNegUqFilter + fLPFTemp * CurrCtrlObject.nNegUq;
//	CurrCtrlObject.nPosUdFilter = CurrCtrlObject.nPosUdFilter +1.0f;//˸е쳣
//	CurrCtrlObject.nPosUqFilter = CurrCtrlObject.nPosUqFilter +1.0f;
//	CurrCtrlObject.nNegUdFilter = CurrCtrlObject.nNegUdFilter +1.0f;
//	CurrCtrlObject.nNegUqFilter = CurrCtrlObject.nNegUqFilter +1.0f;
	
	CurrCtrlObject.nPosId = iInv_dq0_pos.d;
	CurrCtrlObject.nPosIq = iInv_dq0_pos.q;

	CurrCtrlObject.nNegId = iInv_dq0_pos.alpha * fCose - iInv_dq0_pos.beta * fSine;
	CurrCtrlObject.nNegIq = iInv_dq0_pos.alpha * fSine + iInv_dq0_pos.beta * fCose;

	D_P_Temp = CurrCtrlObject.nNegIdFilter * fCose2 + CurrCtrlObject.nNegIqFilter * fSine2;
    Q_P_Temp = CurrCtrlObject.nNegIdFilter * fSine2 - CurrCtrlObject.nNegIqFilter * fCose2;    
    D_N_Temp = CurrCtrlObject.nPosIdFilter * fCose2 - CurrCtrlObject.nPosIqFilter * fSine2;
    Q_N_Temp = CurrCtrlObject.nPosIdFilter * fSine2 + CurrCtrlObject.nPosIqFilter * fCose2;

	CurrCtrlObject.nPosId = CurrCtrlObject.nPosId - D_P_Temp;
    CurrCtrlObject.nPosIq = CurrCtrlObject.nPosIq + Q_P_Temp;
    
    CurrCtrlObject.nNegId = CurrCtrlObject.nNegId - D_N_Temp;
    CurrCtrlObject.nNegIq = CurrCtrlObject.nNegIq - Q_N_Temp;

	//LIMIT(CurrCtrlObject.nPosUd, 4700, 0);
	//LIMIT(CurrCtrlObject.nPosUq, 200, -200);
	//LIMIT(CurrCtrlObject.nNegUd, 690, -1366);
	//LIMIT(CurrCtrlObject.nNegUq, 1200, -1200);

//	FILTER1(CurrCtrlObject.nPosIdFilter,CurrCtrlObject.nPosId,45,fLPFTemp);
//	FILTER1(CurrCtrlObject.nPosIqFilter,CurrCtrlObject.nPosIq,45,fLPFTemp);
//	FILTER1(CurrCtrlObject.nNegIdFilter,CurrCtrlObject.nNegId,45,fLPFTemp);
//	FILTER1(CurrCtrlObject.nNegIqFilter,CurrCtrlObject.nNegIq,45,fLPFTemp);

}

#pragma CODE_SECTION(vRunVoltageLoop2,".TI.ramfunc");
volatile void vRunVoltageLoop2(void)
{
	float fLPFTemp;
	if(usRun_first_flag)
		{
		DCL_resetPI(&dcl_gv_vBanlence);
		dcl_gv_vBanlence_out = 0.0f;

		//BusCtrlObject

		BusCtrlObject.unBusVolIntgReg = 0.0f;
		BusCtrlObject.nBusVolErr = 0.0f;

		BusCtrlObject.nBusVolPIRegOriginal = 0.0f;
		BusCtrlObject.nBusVolPIReg = 0.0f;
		BusCtrlObject.nBusVolPIRegErr = 0.0f;
			
		BusCtrlObject.nBusVolIntgRegLmt = 50.0f;

		NegIqCtrlObject.unBusVolIntgReg = 0.0f;
		NegIqCtrlObject.nBusVolErr = 0.0f;

		NegIqCtrlObject.nBusVolPIRegOriginal = 0.0f;
		NegIqCtrlObject.nBusVolPIReg = 0.0f;
		NegIqCtrlObject.nBusVolPIRegErr = 0.0f;
			
		NegIqCtrlObject.nBusVolIntgRegLmt = 50.0f;

		NegIqCtrlObject.nBusVolPIRegLmt = 50.0f;
		}
	else
		{
		//ĸߵѹ
		if(ctl_closeGvLoop == 1)//ѹ
				{
				BusCtrlObject.nBusVolPIRegLmt = rout_data.Set_Para.sDc_Current_set;
				//FILTER1(BusCtrlObject.nBusVolRef,rout_data.Set_Para.usDc_Voltage_set,1000,fLPFTemp);
				BusCtrlObject.nBusVolRef = dcl_idRef;//rout_data.Set_Para.usDc_Voltage_set;

				FILTER1(BusCtrlObject.nBusVolFeedBack,rout_data.Inst_data.fDCbus_voltage_inst,1000,fLPFTemp);
				//BusCtrlObject.nBusVolFeedBack = rout_data.Inst_data.fDCbus_voltage_inst;//ʵʱĸߵѹ

				BusCtrlObject.nBusVolErr = BusCtrlObject.nBusVolRef - BusCtrlObject.nBusVolFeedBack;
				LIMIT(BusCtrlObject.nBusVolErr, 10.0f, -10.0f);
				BusCtrlObject.unBusVolIntgReg += BusCtrlObject.nBusVolErr * BusCtrlObject.nKi;
				BusCtrlObject.unBusVolIntgReg += BusCtrlObject.nBusVolPIRegErr * BusCtrlObject.nKc;
				LIMIT(BusCtrlObject.unBusVolIntgReg, BusCtrlObject.nBusVolIntgRegLmt , -BusCtrlObject.nBusVolIntgRegLmt);	
				BusCtrlObject.nBusVolPIRegOriginal = BusCtrlObject.unBusVolIntgReg + BusCtrlObject.nBusVolErr * BusCtrlObject.nKp;
				if(BusCtrlObject.nBusVolPIRegOriginal > BusCtrlObject.nBusVolPIRegLmt)
					{
						BusCtrlObject.nBusVolPIReg = BusCtrlObject.nBusVolPIRegLmt;
					}
				else if(BusCtrlObject.nBusVolPIRegOriginal < (-BusCtrlObject.nBusVolPIRegLmt))
					{
						BusCtrlObject.nBusVolPIReg = -BusCtrlObject.nBusVolPIRegLmt;
					}
				else
					{
						BusCtrlObject.nBusVolPIReg = BusCtrlObject.nBusVolPIRegOriginal;
					}
				BusCtrlObject.nBusVolPIRegErr = BusCtrlObject.nBusVolPIReg - BusCtrlObject.nBusVolPIRegOriginal;								

				CurrCtrlObject.nPosIdRef = -BusCtrlObject.nBusVolPIReg;
				}
		else//ŵ
				{
				//dcl_gv_vBanlence_out = DCL_runPI_C2(&dcl_gv_vBanlence,rout_data.Value1_data.fDCbus_up_voltage,rout_data.Value1_data.fDCbus_down_voltage);
				
				CurrCtrlObject.nPosIdRef = dcl_idRef;
				//CurrCtrlObject.nPosIqRef = dcl_iqRef;//0.0f;
				}

			NegIqCtrlObject.nBusVolRef = dcl_iqRef;	
			FILTER1(NegIqCtrlObject.nBusVolFeedBack,iGrid_dq0_pos.q,1000,fLPFTemp);				
			NegIqCtrlObject.nBusVolErr = NegIqCtrlObject.nBusVolRef - NegIqCtrlObject.nBusVolFeedBack;
			LIMIT(NegIqCtrlObject.nBusVolErr, 30.0f, -30.0f);
			NegIqCtrlObject.unBusVolIntgReg += NegIqCtrlObject.nBusVolErr * NegIqCtrlObject.nKi;
			NegIqCtrlObject.unBusVolIntgReg += NegIqCtrlObject.nBusVolPIRegErr * NegIqCtrlObject.nKc;
			LIMIT(NegIqCtrlObject.unBusVolIntgReg, NegIqCtrlObject.nBusVolIntgRegLmt , -NegIqCtrlObject.nBusVolIntgRegLmt);	
			NegIqCtrlObject.nBusVolPIRegOriginal = NegIqCtrlObject.unBusVolIntgReg + NegIqCtrlObject.nBusVolErr * NegIqCtrlObject.nKp;
			if(NegIqCtrlObject.nBusVolPIRegOriginal > NegIqCtrlObject.nBusVolPIRegLmt)
			{
				NegIqCtrlObject.nBusVolPIReg = NegIqCtrlObject.nBusVolPIRegLmt;
			}
			else if(NegIqCtrlObject.nBusVolPIRegOriginal < (-NegIqCtrlObject.nBusVolPIRegLmt))
			{
				NegIqCtrlObject.nBusVolPIReg = -NegIqCtrlObject.nBusVolPIRegLmt;
			}
			else
			{
				NegIqCtrlObject.nBusVolPIReg = NegIqCtrlObject.nBusVolPIRegOriginal;
			}
			NegIqCtrlObject.nBusVolPIRegErr = NegIqCtrlObject.nBusVolPIReg - NegIqCtrlObject.nBusVolPIRegOriginal;	
		
			CurrCtrlObject.nPosIqRef = NegIqCtrlObject.nBusVolPIReg;

		//
		if(usDataRenew_flog)
			{
			usDataRenew_flog = 0;
			//dcl_gv_vBanlence_out = DCL_runPI_C2(&dcl_gv_vBanlence,rout_data.Value1_data.fDCbus_up_voltage,rout_data.Value1_data.fDCbus_down_voltage);
			dcl_gv_vBanlence_out = DCL_runPI_C2(&dcl_gv_vBanlence,0,(rout_data.Value1_data.fDCbus_up_voltage-rout_data.Value1_data.fDCbus_down_voltage));
			}
											
		}
}

#pragma CODE_SECTION(vRunCurrentLoop2,".TI.ramfunc");
volatile void vRunCurrentLoop2(void)
{
	if(usRun_first_flag)
		{
			CurrCtrlObject.unPosIdIntgReg = 0.0f;
			CurrCtrlObject.unPosIqIntgReg = 0.0f;
			CurrCtrlObject.nPosIdErr = 0.0f;
			CurrCtrlObject.nPosIqErr = 0.0f;
			CurrCtrlObject.nPosIdPIRegOriginal = 0.0f;
			CurrCtrlObject.nPosIdPIReg = 0.0f;
			CurrCtrlObject.nPosIdPIRegErr = 0.0f;
			CurrCtrlObject.nPosIqPIRegOriginal = 0.0f;
			CurrCtrlObject.nPosIqPIReg = 0.0f;
			CurrCtrlObject.nPosIqPIRegErr = 0.0f;

			CurrCtrlObject.nPosIdIntgRegLmt = 50.0f;
			CurrCtrlObject.nPosIqIntgRegLmt = 50.0f;
			CurrCtrlObject.nPosIdPIRegLmt = 100.0f;
			CurrCtrlObject.nPosIqPIRegLmt = 100.0f;
			CurrCtrlObject.nPosUdRefLmt = 400.0f;
			CurrCtrlObject.nPosUqRefLmt = 400.0f;


			CurrCtrlObject.unNegIdIntgReg = 0.0f;
			CurrCtrlObject.unNegIqIntgReg = 0.0f;
			CurrCtrlObject.nNegIdErr = 0.0f;
			CurrCtrlObject.nNegIqErr = 0.0f;
			CurrCtrlObject.nNegIdPIRegOriginal = 0.0f;
			CurrCtrlObject.nNegIdPIReg = 0.0f;
			CurrCtrlObject.nNegIdPIRegErr = 0.0f;
			CurrCtrlObject.nNegIqPIRegOriginal = 0.0f;
			CurrCtrlObject.nNegIqPIReg = 0.0f;
			CurrCtrlObject.nNegIqPIRegErr = 0.0f;

			CurrCtrlObject.nNegIdIntgRegLmt = 50.0f;
			CurrCtrlObject.nNegIqIntgRegLmt = 50.0f;
			CurrCtrlObject.nNegIdPIRegLmt = 100.0f;
			CurrCtrlObject.nNegIqPIRegLmt = 100.0f;
			CurrCtrlObject.nNegUdRefLmt = 400.0f;
			CurrCtrlObject.nNegUqRefLmt = 400.0f;
		}
	else
		{
			CurrCtrlObject.nPosIdFeedBack = CurrCtrlObject.nPosId;//CurrCtrlObject.nPosIdFilter;
			CurrCtrlObject.nPosIqFeedBack = CurrCtrlObject.nPosIq;//CurrCtrlObject.nPosIqFilter;
			CurrCtrlObject.nNegIdFeedBack = CurrCtrlObject.nNegId;//CurrCtrlObject.nNegIdFilter;
			CurrCtrlObject.nNegIqFeedBack = CurrCtrlObject.nNegIq;//CurrCtrlObject.nNegIqFilter;

			CurrCtrlObject.nPosDDeco = CurrCtrlObject.nPosIqFeedBack * 0.157f;
			CurrCtrlObject.nPosQDeco = CurrCtrlObject.nPosIdFeedBack * 0.157f;
			CurrCtrlObject.nNegDDeco = CurrCtrlObject.nNegIqFeedBack * 0.157f;
			CurrCtrlObject.nNegQDeco = CurrCtrlObject.nNegIdFeedBack * 0.157f;
			
			//Pos Id Regulation
			CurrCtrlObject.nPosIdErr = CurrCtrlObject.nPosIdRef - CurrCtrlObject.nPosIdFeedBack;
			LIMIT(CurrCtrlObject.nPosIdErr, 50.0f, -50.0f);
			CurrCtrlObject.unPosIdIntgReg += CurrCtrlObject.nPosIdErr * CurrCtrlObject.nKi;
			CurrCtrlObject.unPosIdIntgReg += CurrCtrlObject.nPosIdPIRegErr * CurrCtrlObject.nKc;
			LIMIT(CurrCtrlObject.unPosIdIntgReg, CurrCtrlObject.nPosIdIntgRegLmt , -CurrCtrlObject.nPosIdIntgRegLmt);	
			CurrCtrlObject.nPosIdPIRegOriginal = CurrCtrlObject.unPosIdIntgReg + CurrCtrlObject.nPosIdErr * CurrCtrlObject.nKp;
			if(CurrCtrlObject.nPosIdPIRegOriginal > CurrCtrlObject.nPosIdPIRegLmt)
				{
					CurrCtrlObject.nPosIdPIReg = CurrCtrlObject.nPosIdPIRegLmt;
				}
			else if(CurrCtrlObject.nPosIdPIRegOriginal < (-CurrCtrlObject.nPosIdPIRegLmt))
				{
					CurrCtrlObject.nPosIdPIReg = -CurrCtrlObject.nPosIdPIRegLmt;
				}
			else
				{
					CurrCtrlObject.nPosIdPIReg = CurrCtrlObject.nPosIdPIRegOriginal;
				}
			CurrCtrlObject.nPosIdPIRegErr = CurrCtrlObject.nPosIdPIReg - CurrCtrlObject.nPosIdPIRegOriginal;			
			CurrCtrlObject.nPosUdRef=  + CurrCtrlObject.nPosIdPIReg - CurrCtrlObject.nPosDDeco;				
			LIMIT(CurrCtrlObject.nPosUdRef, CurrCtrlObject.nPosUdRefLmt, -CurrCtrlObject.nPosUdRefLmt);


			//Pos Iq Regulation
			CurrCtrlObject.nPosIqErr = CurrCtrlObject.nPosIqRef - CurrCtrlObject.nPosIqFeedBack;
			LIMIT(CurrCtrlObject.nPosIqErr, 80.0f, -80.0f);
			CurrCtrlObject.unPosIqIntgReg += CurrCtrlObject.nPosIqErr * CurrCtrlObject.nKi;
			CurrCtrlObject.unPosIqIntgReg += CurrCtrlObject.nPosIqPIRegErr * CurrCtrlObject.nKc;
			LIMIT(CurrCtrlObject.unPosIqIntgReg, CurrCtrlObject.nPosIqIntgRegLmt , -CurrCtrlObject.nPosIqIntgRegLmt);	
			CurrCtrlObject.nPosIqPIRegOriginal= CurrCtrlObject.unPosIqIntgReg + CurrCtrlObject.nPosIqErr * CurrCtrlObject.nKp;
			if(CurrCtrlObject.nPosIqPIRegOriginal > CurrCtrlObject.nPosIqPIRegLmt)
				{
					CurrCtrlObject.nPosIqPIReg = CurrCtrlObject.nPosIqPIRegLmt;
				}
			else if(CurrCtrlObject.nPosIqPIRegOriginal < (-CurrCtrlObject.nPosIqPIRegLmt))
				{
					CurrCtrlObject.nPosIqPIReg = -CurrCtrlObject.nPosIqPIRegLmt;
				}
			else
				{
					CurrCtrlObject.nPosIqPIReg = CurrCtrlObject.nPosIqPIRegOriginal;
				}
			CurrCtrlObject.nPosIqPIRegErr = CurrCtrlObject.nPosIqPIReg - CurrCtrlObject.nPosIqPIRegOriginal;
			CurrCtrlObject.nPosUqRef=  CurrCtrlObject.nPosIqPIReg + CurrCtrlObject.nPosQDeco;			
			LIMIT(CurrCtrlObject.nPosUqRef, CurrCtrlObject.nPosUqRefLmt, -CurrCtrlObject.nPosUqRefLmt);


			//Neg Id Regulation
			CurrCtrlObject.nNegIdErr = 0 - CurrCtrlObject.nNegIdFeedBack;
			LIMIT(CurrCtrlObject.nNegIdErr, 10.0f, -10.0f);
			CurrCtrlObject.unNegIdIntgReg += CurrCtrlObject.nNegIdErr * CurrCtrlObject.nKi;
			CurrCtrlObject.unNegIdIntgReg += CurrCtrlObject.nNegIdPIRegErr * CurrCtrlObject.nKc;
			LIMIT(CurrCtrlObject.unNegIdIntgReg, CurrCtrlObject.nNegIdIntgRegLmt , -CurrCtrlObject.nNegIdIntgRegLmt);	
			CurrCtrlObject.nNegIdPIRegOriginal = CurrCtrlObject.unNegIdIntgReg + CurrCtrlObject.nNegIdErr * CurrCtrlObject.nKp;
			if(CurrCtrlObject.nNegIdPIRegOriginal > CurrCtrlObject.nPosIdPIRegLmt)
				{
					CurrCtrlObject.nNegIdPIReg = CurrCtrlObject.nNegIdPIRegLmt;
				}
			else if(CurrCtrlObject.nNegIdPIRegOriginal < (-CurrCtrlObject.nNegIdPIRegLmt))
				{
					CurrCtrlObject.nNegIdPIReg = -CurrCtrlObject.nNegIdPIRegLmt;
				}
			else
				{
					CurrCtrlObject.nNegIdPIReg = CurrCtrlObject.nNegIdPIRegOriginal;
				}
			CurrCtrlObject.nNegIdPIRegErr = CurrCtrlObject.nNegIdPIReg - CurrCtrlObject.nNegIdPIRegOriginal;			
			CurrCtrlObject.nNegUdRef=   CurrCtrlObject.nNegIdPIReg - CurrCtrlObject.nNegDDeco;				
			LIMIT(CurrCtrlObject.nNegUdRef, CurrCtrlObject.nNegUdRefLmt, -CurrCtrlObject.nNegUdRefLmt);


			//Neg Iq Regulation
			CurrCtrlObject.nNegIqErr = 0 - CurrCtrlObject.nNegIqFeedBack;
			LIMIT(CurrCtrlObject.nNegIqErr, 10.0f, -10.0f);
			CurrCtrlObject.unNegIqIntgReg += CurrCtrlObject.nNegIqErr * CurrCtrlObject.nKi;
			CurrCtrlObject.unNegIqIntgReg += CurrCtrlObject.nNegIqPIRegErr * CurrCtrlObject.nKc;
			LIMIT(CurrCtrlObject.unNegIqIntgReg, CurrCtrlObject.nNegIqIntgRegLmt , -CurrCtrlObject.nNegIqIntgRegLmt);	
			CurrCtrlObject.nNegIqPIRegOriginal= CurrCtrlObject.unNegIqIntgReg + CurrCtrlObject.nNegIqErr * CurrCtrlObject.nKp;
			if(CurrCtrlObject.nNegIqPIRegOriginal > CurrCtrlObject.nNegIqPIRegLmt)
				{
					CurrCtrlObject.nNegIqPIReg = CurrCtrlObject.nNegIqPIRegLmt;
				}
			else if(CurrCtrlObject.nNegIqPIRegOriginal < (-CurrCtrlObject.nNegIqPIRegLmt))
				{
					CurrCtrlObject.nNegIqPIReg = -CurrCtrlObject.nNegIqPIRegLmt;
				}
			else
				{
					CurrCtrlObject.nNegIqPIReg = CurrCtrlObject.nNegIqPIRegOriginal;
				}
			CurrCtrlObject.nNegIqPIRegErr = CurrCtrlObject.nPosIqPIReg - CurrCtrlObject.nNegIqPIRegOriginal;
			CurrCtrlObject.nNegUqRef=   CurrCtrlObject.nNegIqPIReg + CurrCtrlObject.nNegQDeco;			
			LIMIT(CurrCtrlObject.nNegUqRef, CurrCtrlObject.nNegUqRefLmt, -CurrCtrlObject.nNegUqRefLmt);

		}

}

#pragma CODE_SECTION(vSVModu,".TI.ramfunc");
volatile void vSVModu(float32_t fAlaph, float32_t fBelta, float32_t fSvIa, float32_t fSvIb, float32_t fSvIc, float32_t fBusdiff)
{
volatile	float32_t fModuAf, fModuBt;          //common referenc vector for all sector
volatile	float32_t fModuAfTemp,fModuBtTemp,fSqrt3ModuAfTemp,fSqrt3ModuBtTemp;
volatile	float32_t fTemp,fTemp1,fTemp2,fTemp3,fTemp4;
volatile	float32_t fFactor1,fFactor2;
volatile	float32_t fIo1,fIo2; 
volatile	float32_t fTa,fTb,fTc; 
volatile	float32_t fTaQ1,fTaQ2,fTbQ1,fTbQ2,fTcQ1,fTcQ2;
volatile	float32_t fPwmTaQ1,fPwmTaQ2,fPwmTbQ1,fPwmTbQ2,fPwmTcQ1,fPwmTcQ2;
volatile	uint16_t usSector = 0,usRegion = 0;
	

	fModuAfTemp = fAlaph;
	fModuBtTemp = fBelta;
	fSqrt3ModuAfTemp = SQRT3 * fModuAfTemp;
	fSqrt3ModuBtTemp = SQRT3 * fModuBtTemp;

	fTemp1 = fModuBtTemp;
	fTemp2 = fModuBtTemp - fSqrt3ModuAfTemp;
	fTemp3 = fModuBtTemp + fSqrt3ModuAfTemp;

	fFactor1 = 0.5f + fBusdiff;
	fFactor2 = 0.5f - fBusdiff;

	/**** <Step 1>***Judge sector ******start*********/
	if(fTemp1>=0)
    {
        if(fTemp2<=0)
        {
            usSector=1;
        }
        else 
        {
            if(fTemp3<=0) 
            { 
                usSector=3;
            }
            else
            {
                usSector=2;
            }
        }
    }
    if(fTemp1<0)
    {
        if(fTemp2>=0)
        {
            usSector=4;
        }
        else 
        {
        	  if(fTemp3>=0)
            {
            	  usSector=6;
            }
            else
            {
            	  usSector=5;
            }
        }
    }
	/****<Step 1>***Judge sector ******End**********/

	/*******<Step 2>*******Referenc vectors in other sector transformed to first sector**********/
	fTemp1= fSqrt3ModuBtTemp * 0.5f;   // Ubeta*sqrt3/2
    fTemp2= fSqrt3ModuAfTemp * 0.5f;   // Ualfa*sqrt3/2

    switch (usSector)  
    {    
        case 1:
            fIo1 =  -fSvIa;  //for B,D,F Region
            fIo2 = fSvIc;    //for A,C,E Region 
            fModuAf = fModuAfTemp;                                         
            fModuBt = fModuBtTemp;	 		                                  
        break;    
                                                              
        case 2:   
            fIo1 =  -fSvIc;  // wModuAfTemp,wModuBtTemp
            fIo2 =  fSvIb;   //                                                               
            fModuAf = fModuAfTemp*0.5f+fTemp1;     //   Ucos(theta-60) = Ualfa/2 + Ubeta*sqrt(3)/2
            fModuBt = fModuBtTemp*0.5f-fTemp2;	    //   Usin(theta-60) = Ubeta/2 - Ualfa*sqrt(3)/2
        break;  
                                                                      
        case 3:   
            fIo1 = -fSvIb;   //
            fIo2 = fSvIa;    //                                                        //   
 		    fModuAf = -fModuAfTemp*0.5f+fTemp1;     //   Ucos(theta-120) = -Ualfa/2 + Ubeta*sqrt(3)/2  
            fModuBt = -fModuBtTemp*0.5f-fTemp2;     //   Usin(theta-120) = -Ubeta/2 - Ualfa*sqrt(3)/2  
        break; 
                                                                   
        case 4:   
            fIo1 =  -fSvIa; // 
            fIo2 = fSvIc;   //                                           
            fModuAf = -fModuAfTemp;                                                             //   Ucos(theta-180) = -Ualfa 
            fModuBt = -fModuBtTemp;                                                             //   Usin(theta-180) = -Ubeta 
        break;
                                                                                          
        case 5:  
            fIo1 = -fSvIc;  //
            fIo2 = fSvIb;   //                          
            fModuAf = -fModuAfTemp*0.5f-fTemp1;     //
            fModuBt = -fModuBtTemp*0.5f+fTemp2;     //
        break; 
                                        
        case 6:
            fIo1 = -fSvIb;
            fIo2 = fSvIa;
            fModuAf = fModuAfTemp*0.5f-fTemp1;
            fModuBt = fModuBtTemp*0.5f+fTemp2;  
        break;
        
        default:
            fIo1 = fSvIa;
            fIo2 = fSvIc;
            fModuAf = fModuAfTemp;
            fModuBt = fModuBtTemp;
        break;
    }
    /********<Step 2>********transformed *****End**********************/

	/********<Step 3>****Judge which region in the first sector ******/
    fTemp = fModuAf*SQRT3;                          //    |     ** 3* *     |
    fTemp1 = fTemp + fModuBt - 1.0f;    //sqrt3*Ualfa + Ubeta - 0x3fff ;   //    |   **---2---**   |	              
    fTemp2 = fTemp - fModuBt - 1.0f;    //sqrt3*Ualfa - Ubeta - 0x3fff ;   //    |  **----*----**  |
    fTemp3 = fModuBt - 0.5f;            //Ubeta - 0x2000 ;                 //    | **1*********4** |
                                                          
    if(fTemp1<=0)  //(AB)
	{
	    usRegion = 1;
	}                                  
	else if(fTemp3>=0)//E
	{ 	                               
	    usRegion = 3;   
	}                                  
	
	else if(fTemp2>=0)  //   F
	{        
	    usRegion = 4; 
	}                                  
	else                               
	{    
	    usRegion = 2;    //CD
    }		
    /********<Step 3>*****Judge **********End *******/ 
	
	/********<Step 4>****compute dwelling time based on the different regions ****Start******/
    fTemp4 = fModuAf*SQRT3DIV3-fModuBt; 
    fTemp1 = fTemp - fModuBt; //sqrt3*Ualfa-Ubeta;
	fTemp2 = fTemp + fModuBt; //sqrt3*Ualfa+Ubeta;
    fTemp3 = fModuBt*2.0f;      //2*Ubeta
    
    switch  (usRegion)
	{
	    case 1:
	        //break;
	    case 2:
	    	if (fTemp4 > 0) //<30 degree C
	    	{                
                fTa = 2.0f-fTemp2;    //4С          D   زͷһС⣬Ϊȥﴦ
	            fTb = fTemp3;                      
                fTc = fTemp1-1.0f;
                  
            }
            else  //>30 degree 
            {
                fTa = fTemp3-1.0f;      //3С            
		        fTb = fTemp1;                      
                fTc = 2.0f-fTemp2;
            }		    			    	
            break;
        case 3:
            fTa = fTemp3-1.0f;                
		    fTb = fTemp1;                      
            fTc = 2.0f-fTemp2;   
        break;
        
        case 4:
            fTa = 2.0f-fTemp2;                
		    fTb = fTemp3;                      
            fTc = fTemp1-1.0f;
        break;
        
        default:
            fTa = fTemp1;
		    fTb = 2.0f-fTemp2;
		    fTc = fTemp3;
	    break;     	                    
    }
    /********<Step 4>****compute dwelling time  **********End *******/ 

	/********<Step 5>****compute three phase switch active time (duty) for first sector ***Start******/         
  	fTemp1 = fModuAf*SQRT3DIV3-fModuBt;
   
    switch (usRegion)
    {              
        case 1:
            //break;
        case 2:
            if(fTemp1>0) 
            {
               if(fIo1<0)
                {
               	    fTemp = fFactor1;
               	    fFactor1 = fFactor2;
               	    fFactor2 = fTemp; 
              	}  
                fTaQ1 = fTa*fFactor1+fTb+fTc; 
                fTaQ2 = 1.0f;
                fTbQ1 = 0.0f;
                fTbQ2 = fTa*fFactor1+fTb;
                fTcQ1 = 0.0f;
                fTcQ2 = fTa*fFactor1; 
            }  
            else 
            {
               if(fIo2<0)
                {
                    fTemp = fFactor1;
                    fFactor1 = fFactor2;
                    fFactor2 = fTemp; 
                }   
                fTaQ1 = fTc*fFactor1+fTa+fTb; 
                fTaQ2 = 1.0f;
                fTbQ1 = fTc*fFactor1+fTa;
                fTbQ2 = 1.0f;
                fTcQ1 = 0.0f;
                fTcQ2 = fTc*fFactor1;
            }
            break;
        case 3:
            if(fIo2<0)
            {
                fTemp = fFactor1;
                fFactor1 = fFactor2;
                fFactor2 = fTemp; 
            }
            fTaQ1 = fTc*fFactor1+fTa+fTb; 
            fTaQ2 = 1.0f;
            fTbQ1 = fTc*fFactor1+fTa;
            fTbQ2 = 1.0f;
            fTcQ1 = 0.0f;
            fTcQ2 = fTc*fFactor1;
            break;
        case 4:
            if(fIo1<0)
            {
                fTemp = fFactor1;
                fFactor1 = fFactor2;
                fFactor2 = fTemp; 
            }
            fTaQ1 = fTa*fFactor1+fTb+fTc; //
            fTaQ2 = 1.0f;
            fTbQ1 = 0.0f;
            fTbQ2 = fTa*fFactor1+fTb;//
            fTcQ1 = 0.0f;
            fTcQ2 = fTa*fFactor1;            
            break;  
        default:
            fTaQ1 =fTc*0.5f+fTa*0.5f+fTb;
            fTaQ2 = 1.0f;
            fTbQ1 = fTc*0.5f;
            fTbQ2 = 1-fTa*0.5f;
            fTcQ1 = 0.0f;
            fTcQ2 = 1-fTc*0.5f-fTa*0.5f;
            break;
    }
    /********<Step 5>****compute three phase switch active time (duty) for first sector ***END *******/ 

	/********<Step 6>****compute three phase switch active time (duty) for six sectors ****START ******/   
    switch(usSector)
    {
        case 1:
            fPwmTaQ1 = fTaQ1;
            fPwmTaQ2 = fTaQ2;
            fPwmTbQ1 = fTbQ1;
            fPwmTbQ2 = fTbQ2;
            fPwmTcQ1 = fTcQ1;
            fPwmTcQ2 = fTcQ2;
            break;
        case 2:
            fPwmTaQ1 = 1.0f-fTbQ2;
            fPwmTaQ2 = 1.0f-fTbQ1;
            fPwmTbQ1 = 1.0f-fTcQ2;
            fPwmTbQ2 = 1.0f-fTcQ1;
            fPwmTcQ1 = 1.0f-fTaQ2;
            fPwmTcQ2 = 1.0f-fTaQ1;
            break;    
        case 3:
            fPwmTaQ1 = fTcQ1;
            fPwmTaQ2 = fTcQ2;
            fPwmTbQ1 = fTaQ1;
            fPwmTbQ2 = fTaQ2;
            fPwmTcQ1 = fTbQ1;
            fPwmTcQ2 = fTbQ2;
            break;
        case 4:
            fPwmTaQ1 = 1.0f-fTaQ2;
            fPwmTaQ2 = 1.0f-fTaQ1;
            fPwmTbQ1 = 1.0f-fTbQ2;
            fPwmTbQ2 = 1.0f-fTbQ1;
            fPwmTcQ1 = 1.0f-fTcQ2;
            fPwmTcQ2 = 1.0f-fTcQ1;
            break;
        case 5:                
            fPwmTaQ1 = fTbQ1;
            fPwmTaQ2 = fTbQ2;
            fPwmTbQ1 = fTcQ1;
            fPwmTbQ2 = fTcQ2;
            fPwmTcQ1 = fTaQ1;
            fPwmTcQ2 = fTaQ2;
            break;
        case 6:
            fPwmTaQ1 = 1.0f-fTcQ2;
            fPwmTaQ2 = 1.0f-fTcQ1;
            fPwmTbQ1 = 1.0f-fTaQ2;
            fPwmTbQ2 = 1.0f-fTaQ1;
            fPwmTcQ1 = 1.0f-fTbQ2;
            fPwmTcQ2 = 1.0f-fTbQ1;
            break;
        default:                  
            fPwmTaQ1 = fTaQ1;
            fPwmTaQ2 = fTaQ2;
            fPwmTbQ1 = fTbQ1;
            fPwmTbQ2 = fTbQ2;
            fPwmTcQ1 = fTcQ1;
            fPwmTcQ2 = fTcQ2;
            break;                                               
    }    
    
	//converte the duty of Q2 (switch 2) to the duty of Q4(switch 4). there are Q1,Q2,Q3,Q4 switchs in every bridge branch 
    fPwmTaQ2 = 1.0f - fPwmTaQ2;
    fPwmTbQ2 = 1.0f - fPwmTbQ2;
    fPwmTcQ2 = 1.0f - fPwmTcQ2;
    
    
    ////Limiter of max PWM and min PWM
    fTemp = fPwmTaQ1 + fPwmTaQ2 - 1.0f;
    if(fTemp > 0)
    {
        fPwmTaQ1 = fPwmTaQ1 - fTemp*0.5f;
        fPwmTaQ2 = fPwmTaQ2 - fTemp*0.5f;
    }
    
    fTemp = fPwmTbQ1 + fPwmTbQ2 - 1.0f;
    if(fTemp > 0)
    {
        fPwmTbQ1 = fPwmTbQ1 - fTemp*0.5f;
        fPwmTbQ2 = fPwmTbQ2 - fTemp*0.5f;
    }
    
    fTemp =fPwmTcQ1 + fPwmTcQ2 - 1.0f;
    if(fTemp > 0)
    {
        fPwmTcQ1 = fPwmTcQ1 - fTemp*0.5f;
        fPwmTcQ2 = fPwmTcQ2 - fTemp*0.5f;
    }
                                          
    //Limiter of max PWM and min PWM
    if(fPwmTaQ1>1.0f)
    {
        fPwmTaQ1 = 1.0f;
    }
    if(fPwmTaQ1<cMinPwm)
    {
    	fPwmTaQ1 = 0; 
    }  
    
    if(fPwmTaQ2>cMaxPwm)
    {
    	fPwmTaQ2 = cMaxPwm;
    }
    if(fPwmTaQ2<cMinPwm)
    {
    	fPwmTaQ2 = 0; 
    }
      
    if(fPwmTbQ1>cMaxPwm)
    {
    	fPwmTbQ1 = cMaxPwm;
    }
    if(fPwmTbQ1<cMinPwm)
    {
    	fPwmTbQ1 = 0;
    } 
    if(fPwmTbQ2>cMaxPwm)
    {
    	fPwmTbQ2 = cMaxPwm;
    }
    if(fPwmTbQ2<cMinPwm)
    {
    	fPwmTbQ2 = 0;  
    }              
                       
    if(fPwmTcQ1>cMaxPwm)
    {
    	fPwmTcQ1 = cMaxPwm;
    }
    if(fPwmTcQ1<cMinPwm)
    { 
    	fPwmTcQ1 = 0;
    }                                
      
    if(fPwmTcQ2>cMaxPwm)
    {
    	fPwmTcQ2 = cMaxPwm;
    }
    if(fPwmTcQ2<cMinPwm)
    {
    	fPwmTcQ2 = 0; 
    }
    /********<Step 6>****compute three phase switch active time (duty) for six sectors ****END *******/ 
	PWM_duty_A=  fPwmTaQ1;
    PWM_duty_A2 = fPwmTaQ2;
    PWM_duty_B = fPwmTbQ1;
    PWM_duty_B2 = fPwmTbQ2;
    PWM_duty_C = fPwmTcQ1;
    PWM_duty_C2 = fPwmTcQ2;
	
}






































