/**
  ******************************************************************************
  * @file    routing.c
  * @author  
  * @version V1.0.0
  * @date    
  * @brief   
  *****************************************************************************/
#include "routing.h"
#include "spi_device.h"
#include "gpio_device.h"
#include "ecap_device.h"
#include "pwm_device.h"
#include <math.h>
#include "rampgen.h"
#include "main_math.h"


Sys_dt_t rout_data;
TCurrCtrl volatile CurrCtrlObject;
TBusCtrl volatile BusCtrlObject ,NegIqCtrlObject;


static float * pfTp0 = &rout_data.Inst_data.fInvert_voltage_U_inst;
//static float * pfTp1 = &rout_data.Value1_data.fGrid_voltage_A;
//static uint16_t * pfTp2 = &rout_data.Value2_data.usRun_mode_states;
static uint16_t *pusOffaddr = &rout_data.Debug_Para.usData1_cache_addr;


//static uint16_t usFan_Speed_Level = 3;
//static uint16_t usFan_Speed_Cnt = 0;

volatile float32_t angle_radians;
RAMPGEN ANPCINV_rgen;
float32_t sine_A,sine_B,sine_C;
volatile int32_t CONF_clearPWMTrip;
float32_t fSine,fCose;
float32_t fSine_pll,fCose_pll;
float32_t fSine2,fCose2;//2Ƕ


float32_t fSineB,fCoseB;
float32_t fSineC,fCoseC;

static uint16_t usAdChannelState = 0;
static uint16_t usAdTempState = 0;
uint16_t sTempBuf[2][8];


extern ABC_DQ0_POS vGrid_dq0_pos;
extern ABC_DQ0_POS vGrid_dq0_pos_filter;
extern ABC_DQ0_NEG vGrid_dq0_neg;
extern ABC_DQ0_POS iInv_dq0_pos;
extern ABC_DQ0_POS iInv_dq0_pos_filter;
extern ABC_DQ0_POS iGrid_dq0_pos;
extern DQ0_ABC vInv_dq0;
extern DQ0_ABC vInv_dq0_ref;

extern SPLL_3PH_DDSRF  spll_3ph_1;
extern SPLL_3PH_DQ spll_3ph;

extern float32_t dcl_vdInv;
extern float32_t dcl_vqInv;
extern float32_t dcl_vzInv;
extern volatile int32_t ctl_pll_ref;

float32_t PWM_duty_A;
float32_t PWM_duty_B;
float32_t PWM_duty_C;
float32_t PWM_duty_A2;
float32_t PWM_duty_B2;
float32_t PWM_duty_C2;


volatile float32_t slow_slip;
volatile uint16_t usRun_first_flag = 0;
volatile uint16_t usDataRenew_flog = 0;
volatile uint16_t usGridInvert_syn ;
volatile uint16_t usDcvoltage_syn ;


float32_t fPll_angle_step = 0.01570797f;
float32_t fLCL_cur_Kp;
float32_t fRC_pwm_KP;
float32_t fRC_pwm_KC;
float32_t k_ce;

float32_t fiInv_d_filter;
float32_t fiInv_q_filter;

static uint16_t usBanlence_index = 0;
float fBanlence_voltage_up;
float fBanlence_voltage_dw;
float fBanlence_voltage_up_sum;
float fBanlence_voltage_dw_sum;

extern uint16_t ARM_RUN_FLAG;


void vRoutine_init(void)
{
    char cSoft_version1[VERSION_LENTH_MAX] = "V0.1.0.0117.001";
    char cSoft_version2[VERSION_LENTH_MAX] = "V0.2.0.1227.006";
	uint8_t i;
	rout_data.Debug_Para.usDebug_cmd = DEBUG_CMD_CALI;//ȱʡʾDEBUG_CMD_REAL

	rout_data.Debug_Para.usData1_cache_addr = 0;
	rout_data.Debug_Para.usData2_cache_addr = 1;
	rout_data.Debug_Para.usData3_cache_addr = 2;
	rout_data.Debug_Para.usData4_cache_addr = 3;
	rout_data.Debug_Para.usData5_cache_addr = 4;
	rout_data.Debug_Para.usData6_cache_addr = 5;

/*	for(i = 0;i < (sizeof(Real_Value1_dt)>>1);i++)
		*(pfTp1+i) = i+101;
	
	for(i = 0;i < (sizeof(Real_Value2_dt) - 64);i++)
	    *(pfTp2+i) = i+1001;*/

	//rout_data.Value2_data.cDsp1_soft_version = atoi(cSoft_version1);
    //rout_data.Value2_data.cDsp2_soft_version = atoi(cSoft_version2);

	for(i = 0;i < VERSION_LENTH_MAX ;i++)
        {
	    //sprintf(rout_data.Value2_data.cDsp1_soft_version[i],"%d",cSoft_version1[i]);
	    rout_data.Value2_data.cDsp1_soft_version[i] = (uint16_t)cSoft_version1[i];
	    rout_data.Value2_data.cDsp2_soft_version[i] = (uint16_t)cSoft_version2[i];
        }

//	rout_data.Value2_data.cDsp1_soft_version = "V0.2.0.1219";

	rout_data.Value2_data.usRun_mode_states = DEVICE_ILDE;

	RAMPGEN_reset(&ANPCINV_rgen);
    RAMPGEN_config(&ANPCINV_rgen,
                    CONF_PWM_SWITCHING_FREQ_HZ,
                    (float32_t)50.0);

	CONF_clearPWMTrip = 1;
	ctl_pll_ref = 0;
	rout_data.Inst_data.fPll_angle = 0;
}


#pragma CODE_SECTION(vRoutine,".TI.ramfunc");
void vRoutine(void)
{
	uint16_t i;
	uint8_t uxSpitxBuf[12];
	int16_t sTemp;
	int32_t temp;
	float32_t fTemp;
	//float32_t kpwm;
	//float32_t kpwm_up,kpwm_dw;
	float32_t fProtect_H;
	float32_t fProtect_L;
	float32_t fPosAlpha_Temp,fNegAlpha_Temp,fPosBeta_Temp,fNegBeta_Temp;
	float32_t fAlpha_Temp,fBeta_Temp,fBusdif;

		/* ǰ㷨 */
	//static uint32_t ahead_period = 3; /* ǰ */

	//static float new_out_a1,new_out_b1,new_out_c1;
	//static unsigned int ahead_n = 0;


	//static float  Repetive_A1,Repetive_B1,Repetive_C1;

	if(CONF_clearPWMTrip == 1)
		{
		CONF_clearPWMTrip = 0;
		CONF_clearPWMTripFlags();
		CONF_disablePWM();//ȫõ͵ƽ
		}

	//HAL_updateFANPWMduty(50);
	HAL_readADadnDeal();
	HAL_readADchannelDeal(usAdChannelState,usAdTempState);
	
	if((usAdChannelState%2) == 0) //10k
		{
		//
		rout_data.Inst_data.fDCbus_voltage_inst = rout_data.Inst_data.fDCbusMP_voltage_inst + rout_data.Inst_data.fDCbusMN_voltage_inst;
		usDataRenew_flog = 1;
		}

	if((usAdChannelState%4) == 1) //5k
		{
		vPower_meas_sine();
		}
	
	if(++usAdChannelState > 23) //20k/24
		{
		usAdTempState = (usAdTempState+1)%2;
		//vGetTemperature();
		usAdChannelState = 0;
		}

	if(rout_data.Debug_Para.usDebug_cmd == DEBUG_CMD_REAL)
	{
		for(i = 0;i < 6;i++)
		{
			sTemp = (int16_t)((*(pfTp0 + (*(pusOffaddr + i)))) * (float)10.0);

			uxSpitxBuf[i*2] = (sTemp>>8)&0xff;
			uxSpitxBuf[i*2 + 1] = sTemp&0xff;	
		}
	}
	else if(rout_data.Debug_Para.usDebug_cmd == DEBUG_CMD_CALI)
	{
		//memcpy(temp,pfTp+ (*pusOffaddr + i),2);
		for(i = 0;i < 3;i++)
		{
			memcpy(&temp,pfTp0+(*(pusOffaddr + i)),2);
			
			uxSpitxBuf[i*4] =     (temp >> 24)&0xff;
			uxSpitxBuf[i*4 + 1] = (temp >> 16)&0xff;
			uxSpitxBuf[i*4 + 2] = (temp >> 8)&0xff;
			uxSpitxBuf[i*4 + 3] = (temp )&0xff;

			//(uint8*)(uxSpitxBuf + i*4) = (uint8*)(pfTp + (*pusOffaddr + i));
			//memcpy(uxSpitxBuf + i*4,(uint8*)(pfTp + (*pusOffaddr + i)),4);

			
		}
	}
	else
	{
		uxSpitxBuf[0] = 0xff;
	}
	if(ARM_RUN_FLAG)  
		vSpic_xframe(uxSpitxBuf,12);

	//ֱĸߵѹ˲
	FILTER1(rout_data.Value1_data.fDCbus_up_voltage,rout_data.Inst_data.fDCbusMP_voltage_inst,60,fTemp);
	FILTER1(rout_data.Value1_data.fDCbus_down_voltage,rout_data.Inst_data.fDCbusMN_voltage_inst,60,fTemp);
	rout_data.Value1_data.fDCbus_sum_voltage = rout_data.Value1_data.fDCbus_up_voltage + rout_data.Value1_data.fDCbus_down_voltage;

	FILTER1(rout_data.Value1_data.fDc_voltage_avg,rout_data.Inst_data.fDCbat_voltage_inst,2,fTemp);

	rout_data.Inst_data.fLCL_current_A_inst = rout_data.Inst_data.fInvert_current_U1_inst + rout_data.Inst_data.fGrid_current_A_inst;
	rout_data.Inst_data.fLCL_current_B_inst = rout_data.Inst_data.fInvert_current_V1_inst + rout_data.Inst_data.fGrid_current_B_inst;
	rout_data.Inst_data.fLCL_current_C_inst = rout_data.Inst_data.fInvert_current_W1_inst + rout_data.Inst_data.fGrid_current_C_inst;
	//
	{
	fProtect_H = (float)rout_data.Set_Para.ulDC_maxChargeCurrent_thre;
	fProtect_L = -fProtect_H;
	if((rout_data.Inst_data.fInvert_current_U1_inst > fProtect_H)||
		(rout_data.Inst_data.fInvert_current_U1_inst < fProtect_L))
		{
			rout_data.Value2_data.usSys_err_flag1 |= ERR_PFC_SOFT;
			rout_data.Value2_data.usSys_err_flag2 |= ERR_SOFT_INV_MA_CRU;
		}
	if((rout_data.Inst_data.fInvert_current_V1_inst > fProtect_H)||
		(rout_data.Inst_data.fInvert_current_V1_inst < fProtect_L))
		{
			rout_data.Value2_data.usSys_err_flag1 |= ERR_PFC_SOFT;
			rout_data.Value2_data.usSys_err_flag2 |= ERR_SOFT_INV_MB_CRU;
		}
	if((rout_data.Inst_data.fInvert_current_W1_inst > fProtect_H)||
		(rout_data.Inst_data.fInvert_current_W1_inst < fProtect_L))
		{
			rout_data.Value2_data.usSys_err_flag1 |= ERR_PFC_SOFT;
			rout_data.Value2_data.usSys_err_flag2 |= ERR_SOFT_INV_MC_CRU;
		}

	if((rout_data.Inst_data.fGrid_current_A_inst > fProtect_H)||
		(rout_data.Inst_data.fGrid_current_A_inst < fProtect_L))
		{
			rout_data.Value2_data.usSys_err_flag1 |= ERR_PFC_SOFT;
			rout_data.Value2_data.usSys_err_flag2 |= ERR_SOFT_GRID_A_CRU;
		}
	if((rout_data.Inst_data.fGrid_current_B_inst > fProtect_H)||
		(rout_data.Inst_data.fGrid_current_B_inst < fProtect_L))
		{
			rout_data.Value2_data.usSys_err_flag1 |= ERR_PFC_SOFT;
			rout_data.Value2_data.usSys_err_flag2 |= ERR_SOFT_GRID_B_CRU;
		}
	if((rout_data.Inst_data.fGrid_current_C_inst > fProtect_H)||
		(rout_data.Inst_data.fGrid_current_C_inst < fProtect_L))
		{
			rout_data.Value2_data.usSys_err_flag1 |= ERR_PFC_SOFT;
			rout_data.Value2_data.usSys_err_flag2 |= ERR_SOFT_GRID_C_CRU;
		}

	fProtect_H = (float)rout_data.Set_Para.ulDc_maxVoltage_thre * 1.1f;
	if(rout_data.Inst_data.fDCbus_voltage_inst > fProtect_H)
		{
			rout_data.Value2_data.usSys_err_flag1 |= ERR_PFC_SOFT;
			rout_data.Value2_data.usSys_err_flag2 |= ERR_SOFT_DC_SUM_VOL;
		}
	}


/*	SPLL_3PH_DQ_run(&spll_3ph,rout_data.Inst_data.fInvert_voltage_U_inst,rout_data.Inst_data.fInvert_voltage_V_inst,rout_data.Inst_data.fInvert_voltage_W_inst,fSine_pll,fCose_pll);
	fSine_pll = __sin(spll_3ph.f32Theta);
    fCose_pll = __cos(spll_3ph.f32Theta);
	
//	if(ctl_pll_ref)
		{
		rout_data.Inst_data.fPll_angle += fPll_angle_step;
		if(rout_data.Inst_data.fPll_angle > 6.2831924f)
			rout_data.Inst_data.fPll_angle -= 6.2831924f;
		}
//	else
//		{
//		rout_data.Inst_data.fPll_angle = spll_3ph.f32Theta - 0.036f + (float)rout_data.Set_Para.usLocal_second_set*0.0001f; //ǶȲ
//		if(rout_data.Inst_data.fPll_angle > 6.283185207f)
//			rout_data.Inst_data.fPll_angle -= 6.283185207f;
//		else if(rout_data.Inst_data.fPll_angle < -6.283185207f)
//			rout_data.Inst_data.fPll_angle += 6.283185207f;
//		}
	
    fSine = __sin(rout_data.Inst_data.fPll_angle);
    fCose = __cos(rout_data.Inst_data.fPll_angle);

	fSine2 = __sin(rout_data.Inst_data.fPll_angle * 2.0f);
    fCose2 = __cos(rout_data.Inst_data.fPll_angle * 2.0f);

	if(rout_data.Value2_data.usSys_err_flag1 != 0)
		{
		rout_data.Set_Para.usRun_stop = CTL_STOP;
		rout_data.Value2_data.usRun_mode_states = DEVICE_GENERAL_ERR;	
		CONF_disablePWM();
	//	return;
		}

	ABC_DQ0_POS_run(&vGrid_dq0_pos,
            rout_data.Inst_data.fInvert_voltage_U_inst,
            rout_data.Inst_data.fInvert_voltage_V_inst,
            rout_data.Inst_data.fInvert_voltage_W_inst,
            fSine, fCose);
				

	
	ABC_DQ0_POS_run(&iInv_dq0_pos,
               rout_data.Inst_data.fInvert_current_U1_inst,
               rout_data.Inst_data.fInvert_current_V1_inst,
               rout_data.Inst_data.fInvert_current_W1_inst,
               fSine, fCose);

			   
	ABC_DQ0_POS_run(&iGrid_dq0_pos,
               -rout_data.Inst_data.fGrid_current_A_inst,
               -rout_data.Inst_data.fGrid_current_A_inst,
               -rout_data.Inst_data.fGrid_current_A_inst,
               fSine, fCose);

//	if((rout_data.Value2_data.usRun_mode_states != DEVICE_RUN)&&(rout_data.Value2_data.usRun_mode_states != DEVICE_RUN_OVER))
//		return;
			   
//	vSequenceSep();   		//쳣	illegalOperat

	FILTER1(CurrCtrlObject.nPosUdFilter,CurrCtrlObject.nPosUd,45,fTemp);	//ܿȻϵͳͣλ       volatileηԷں
	FILTER1(CurrCtrlObject.nPosUqFilter,CurrCtrlObject.nPosUq,45,fTemp);
	FILTER1(CurrCtrlObject.nNegUdFilter,CurrCtrlObject.nNegUd,45,fTemp);
	FILTER1(CurrCtrlObject.nNegUqFilter,CurrCtrlObject.nNegUq,45,fTemp);
	FILTER1(CurrCtrlObject.nPosIdFilter,CurrCtrlObject.nPosId,45,fTemp);
	FILTER1(CurrCtrlObject.nPosIqFilter,CurrCtrlObject.nPosIq,45,fTemp);
	FILTER1(CurrCtrlObject.nNegIdFilter,CurrCtrlObject.nNegId,45,fTemp);
	FILTER1(CurrCtrlObject.nNegIqFilter,CurrCtrlObject.nNegIq,45,fTemp);

//	vRunVoltageLoop2();		//

//	vRunCurrentLoop2();		//쳣  LED1˸ȥغ

	fPosAlpha_Temp =  CurrCtrlObject.nPosUdRef * fCose - CurrCtrlObject.nPosUqRef * fSine;
	fPosBeta_Temp  =  CurrCtrlObject.nPosUdRef * fSine + CurrCtrlObject.nPosUqRef * fCose;
	fNegAlpha_Temp =  CurrCtrlObject.nNegUdRef * fCose + CurrCtrlObject.nNegUqRef * fSine;
	fNegBeta_Temp  = -CurrCtrlObject.nNegUdRef * fSine + CurrCtrlObject.nNegUqRef * fCose;
	
	vInv_dq0.alpha =  fPosAlpha_Temp + fNegAlpha_Temp;
	vInv_dq0.beta =	  fPosBeta_Temp +  	fNegBeta_Temp;*/

/*	rout_data.Inst_data.fPWM_A = BusCtrlObject.nBusVolRef;				//41
	rout_data.Inst_data.fPWM_B = BusCtrlObject.nBusVolFeedBack;
	rout_data.Inst_data.fPWM_C = BusCtrlObject.nBusVolPIReg;

	rout_data.Inst_data.fDebugtemp1 = CurrCtrlObject.nPosIdFeedBack;
	rout_data.Inst_data.fDebugtemp2 = CurrCtrlObject.nPosIdRef;	
	rout_data.Inst_data.fDebugtemp3 = CurrCtrlObject.nPosIdPIReg;	

	//Դ
	vInv_dq0.a -= rout_data.Inst_data.fLCL_current_A_inst * fLCL_cur_Kp;
	vInv_dq0.b -= rout_data.Inst_data.fLCL_current_B_inst * fLCL_cur_Kp;
	vInv_dq0.c -= rout_data.Inst_data.fLCL_current_C_inst * fLCL_cur_Kp;

	kpwm_up = 1.0f/rout_data.Value1_data.fDCbus_up_voltage;
	kpwm_dw = 1.0f/rout_data.Value1_data.fDCbus_down_voltage;
	
	if(vInv_dq0.a > 0)
		PWM_duty_A = vInv_dq0.a * kpwm_up;
	else
		PWM_duty_A = vInv_dq0.a * kpwm_dw;

	if(vInv_dq0.b > 0)
		PWM_duty_B = vInv_dq0.b * kpwm_up;
	else
		PWM_duty_B = vInv_dq0.b * kpwm_dw;

	if(vInv_dq0.c > 0)
		PWM_duty_C = vInv_dq0.c * kpwm_up;
	else
		PWM_duty_C = vInv_dq0.c * kpwm_dw;*/

	fAlpha_Temp = vInv_dq0.alpha  / (rout_data.Value1_data.fDCbus_sum_voltage * 0.5f);
	fBeta_Temp = vInv_dq0.beta / (rout_data.Value1_data.fDCbus_sum_voltage * 0.5f);
	fBusdif = dcl_gv_vBanlence_out / (rout_data.Value1_data.fDCbus_sum_voltage * 0.5f);

/*	DQ0_ABC_run(&vInv_dq0_ref,
              CurrCtrlObject.nPosIdRef, CurrCtrlObject.nPosIqRef, 0,
              fSine, fCose);	

	vSVModu(fAlpha_Temp,fBeta_Temp,
			vInv_dq0_ref.a,vInv_dq0_ref.b,vInv_dq0_ref.c,
			fBusdif);*/
	


//	DQ0_ABC_run(&vInv_dq0,
 //             10.0f, 0.0f, 0.0f,
 //             fSine, fCose);



////////////////////////////////////////////////////////////////////////////////˴϶쳣
	vSVModu(fSine,fCose,
			vInv_dq0.a,vInv_dq0.b,vInv_dq0.c,
			0);
///////////////////////////////////////////////////////////////////////////////
	if(0)
	{	
		//CONF_HAL_updatePWMDuty(PWM_duty_A,PWM_duty_B,PWM_duty_C);
		CONF_HAL_updatePWMDuty_SVPWM(PWM_duty_A,PWM_duty_A2,PWM_duty_B,PWM_duty_B2,PWM_duty_C,PWM_duty_C2);
		if(usRun_first_flag)
			CONF_enablePWM();
	}

	if(usRun_first_flag)//ÿǰʼ
		usRun_first_flag = 0;
}


