#ifndef __ROUTING_H
#define __ROUTING_H

#include "sys_config.h"
#include "FreeRTOS.h"
#include "task.h"


#define VERSION_LENTH_MAX	32	
#define CALIB_DATA_LENTH_MAX	20	

#define TINV_PI ((float32_t)3.141592653589)


//ʵʱ˲ʱֵADֵУ˲ǰʵ
typedef struct
{
	float	fInvert_voltage_U_inst;		//0
	float	fInvert_voltage_V_inst;
	float	fInvert_voltage_W_inst;

	float	fInvert_current_U1_inst;	//3
	float	fInvert_current_V1_inst;
	float	fInvert_current_W1_inst;	

	float	fInvert_current_U2_inst;	//6
	float	fInvert_current_V2_inst;
	float	fInvert_current_W2_inst;	
	
	float	fGrid_current_A_inst;		//9
	float	fGrid_current_B_inst;
	float	fGrid_current_C_inst;
	
	float	fDCbat_voltage_inst;		//12	

	//4051 CS 
	float	fDCbusMP_voltage_inst;		//13
	float	fDCbusMN_voltage_inst;		//14
	float	fDCbusFP_voltage_inst;		//15
	float	fDCbusFN_voltage_inst;		//16	

	float	fGrid_voltage_A_inst;		//17
	float	fGrid_voltage_B_inst;
	float	fGrid_voltage_C_inst;
	
	float	fOffGrid_voltage_A_inst;	//20
	float	fOffGrid_voltage_B_inst;
	float	fOffGrid_voltage_C_inst;

	float	fInvert_voltage_filter_U_inst;	//23
	float	fInvert_voltage_filter_V_inst;
	float	fInvert_voltage_filter_W_inst;

	float	fV12_monitor_inst;			//26
	float	fVref3_monitor_inst;	

	float	fTemp_in_inst;			//28
	float	fTemp_out_inst;	
	float	fTemp_m_a_inst;	
	float	fTemp_m_b_inst;	
	float	fTemp_m_c_inst;	
	float	fTemp_f_a_inst;	
	float	fTemp_f_b_inst;	
	float	fTemp_f_c_inst;	

	float	fLCL_current_A_inst;	//36
	float	fLCL_current_B_inst;
	float	fLCL_current_C_inst;

	//ֵ
	float	fPll_angle;					//39
	float	fDCbus_voltage_inst;		//40

	float	fPWM_A;					//41
	float	fPWM_B;
	float	fPWM_C;

	float	fDebugtemp1;			//44
	float	fDebugtemp2;
	float	fDebugtemp3;
}Real_Inst_dt;


typedef struct
{
	float	fGrid_voltage_A;
	float	fGrid_voltage_B;
	float	fGrid_voltage_C;

	float	fGrid_current_A;
	float	fGrid_current_B;
	float	fGrid_current_C;

	float	fInvert_voltage_U;
	float	fInvert_voltage_V;
	float	fInvert_voltage_W;

	float	fInvert_current_U;
	float	fInvert_current_V;
	float	fInvert_current_W;

	float	fPower_factor_A;	
	float	fPower_factor_B;
	float	fPower_factor_C;

	float	fGrid_activeP_avg;
	float	fGrid_reactiveP_avg;
	float	fGrid_apparentP_avg;
	float	fGrid_Power_factor;

	float	fLoad_activeP_avg;
	float	fLoad_reactiveP_avg;
	float	fLoad_apparentP_avg;
	float	fLoadPower_factor;	

	float	fSys_frequ_avg;

	float	fBattery_current;
	float	fBattery_voltage;

	float	fDCbus_sum_voltage;
	float	fDCbus_up_voltage;
	float	fDCbus_down_voltage;
	
	float	fDc_voltage_avg;
	float	fDc_current_avg;
	float	fDc_power_avg;

}Real_Value1_dt;

/*  usRun_mode_states  */
#define DEVICE_ILDE 		0
#define DEVICE_STOP 		1
#define DEVICE_START 		2
#define DEVICE_CHARGING		3
#define DEVICE_CHARGED 		4
#define DEVICE_GENERAL_ERR	7	//һԹϣλ
#define DEVICE_SERIOUS_ERR	8	//عϣҪ
#define DEVICE_RUN_READY	9
#define DEVICE_RUN			10
#define DEVICE_RUN_OVER		11

#define DEVICE_DEBUG_MODE	66

/*  usSys_err_flag1  */
#define ERR_INV_A_OI_CMPSS	0X01
#define ERR_INV_B_OI_CMPSS	0X02
#define ERR_INV_C_OI_CMPSS	0X04
#define ERR_PFC_CHANGE_FAIL	0X08
#define ERR_PFC_DISCHANGE_FAIL	0X10
#define ERR_PFC_SOFT		0X20

/*  usSys_err_flag2  */
#define ERR_SOFT_INV_MA_CRU 0X01
#define ERR_SOFT_INV_MB_CRU 0X02
#define ERR_SOFT_INV_MC_CRU 0X04
#define ERR_SOFT_GRID_A_CRU 0X08
#define ERR_SOFT_GRID_B_CRU 0X10
#define ERR_SOFT_GRID_C_CRU 0X20
#define ERR_SOFT_DC_SUM_VOL 0X40

/*  usCharge_states  */
#define CHARGE_EN	0X01
#define CHARGE_DIS	0X02

typedef struct
{
	uint16_t	usRun_mode_states;
	uint16_t	usCharge_states;
	uint16_t	usRelay_states;
	uint16_t	usSys_err_flag1;
	uint16_t	usSys_err_flag2;
	uint16_t	usSys_err_flag3;
	//uint16_t	usSys_err_flag5;
	uint16_t  	usSys_warming_flag;

	int16_t	sInvert_dc_U;
	int16_t	sInvert_dc_V;
	int16_t	sInvert_dc_W;

	int16_t	sTemperature1;
	int16_t	sTemperature2;
	int16_t	sTemperature3;
	int16_t	sTemperature4;
	int16_t	sTemperature5;
	int16_t	sTemperature6;
	int16_t	sTemperature7;
	int16_t	sTemperature8;

	uint16_t sFanspeed1;
	uint16_t sFanspeed2;
	uint16_t sFanspeed3;	
		
	uint16_t	usBattery_status;
	uint16_t	usBattery_warm_low;
	uint16_t	usBattery_warm_mid;
	uint16_t	usBattery_warm_high;

	int16_t		sBMS_current;
	uint16_t	usBMS_SOC;
	uint16_t	usBMS_SOH;

	uint16_t	usCell_maxVoltage_index;
	uint16_t	usCell_maxVoltage;
	uint16_t	usCell_minVoltage_index;
	uint16_t	usCell_minVoltage;
	uint16_t	usCell_maxTemperature_index;
	uint16_t	usCell_maxTemperature;
	uint16_t	usCell_minTemperature_index;
	uint16_t	usCell_minTemperature;

	uint16_t	usLocal_address;
	uint16_t	usDevice_ratedPower;	//
	
	 uint16_t 	cDsp1_soft_version[VERSION_LENTH_MAX];
	 uint16_t 	cDsp2_soft_version[VERSION_LENTH_MAX];
}Real_Value2_dt;


typedef struct
{
	float   fMultip_radio1;
	float   sOffset_coeff1;
	float   fMultip_radio2;
	float   sOffset_coeff2;
	float   fMultip_radio3;
	float   sOffset_coeff3;
	float   fMultip_radio4;
	float   sOffset_coeff4;
	float   fMultip_radio5;
	float   sOffset_coeff5;
	float   fMultip_radio6;
	float   sOffset_coeff6;
	float   fMultip_radio7;
	float   sOffset_coeff7;
	float   fMultip_radio8;
	float   sOffset_coeff8;
	float   fMultip_radio9;
	float   sOffset_coeff9;
	float   fMultip_radio10;
	float   sOffset_coeff10;

	float   fMultip_radio11;
	float   sOffset_coeff11;
	float   fMultip_radio12;
	float   sOffset_coeff12;
	float   fMultip_radio13;
	float   sOffset_coeff13;
	float   fMultip_radio14;
	float   sOffset_coeff14;
	float   fMultip_radio15;
	float   sOffset_coeff15;
	float   fMultip_radio16;
	float   sOffset_coeff16;
	float   fMultip_radio17;
	float   sOffset_coeff17;
	float   fMultip_radio18;
	float   sOffset_coeff18;
	float   fMultip_radio19;
	float   sOffset_coeff19;
	float   fMultip_radio20;
	float   sOffset_coeff20;
}Calib_Para_dt;

/***usRun_stop****/
#define CTL_STOP	0X0
#define CTL_RUN		0X1

/***usRun_mode****/
#define GRID_AC_POWER		0X01
#define GRID_DC_POWER		0X02
#define OFFGRID_AC			0X04

#define CHARGE				0X01
#define DISCHARGE			0X02
#define DISCHARGE_OFF		0X04

typedef struct
{
	uint16_t	usRun_stop;		//ػ
	uint16_t	usRun_mode;		//ģʽ
	uint16_t	usWire_mode;	//߷ʽ 3p3w/3p4w

	uint16_t	usParallel_mode;	//ģʽ
	uint16_t	usParallel_num;

	uint16_t	usRun_cmd;
	uint16_t	usRun_cmd_data1;
	uint16_t	usRun_cmd_data2;

	uint16_t	ulDc_maxVoltage_thre;
	uint16_t	ulDc_minVoltage_thre;
	uint16_t	ulDC_maxChargeCurrent_thre;
	uint16_t	ulDC_maxDisChargeCurrent_thre;
	uint16_t	ulDC_maxChargePower_thre;
	uint16_t	ulDC_maxDisChargePower_thre;

	uint16_t	ulAC_maxDisChargeFrequ_thre;
	uint16_t	ulAC_minChargeFrequ_thre;
	uint16_t	ulAC_maxFrequ_thre;
	uint16_t	ulAC_minFrequ_thre;

	uint16_t	usBattery_maxChargeCurrent_thre;
	uint16_t	usBattery_maxDisChargeCurrent_thre;

	uint16_t	usBattery_maxChargePower_thre;
	uint16_t	usBattery_maxDisChargePower_thre;

	uint16_t	usLocal_year_set;
	uint16_t	usLocal_month_set;
	uint16_t	usLocal_day_set;
	uint16_t	usLocal_hour_set;
	uint16_t	usLocal_minute_set;
	uint16_t	usLocal_second_set;

	uint16_t	ulLocal_ipaddr1;
	uint16_t	ulLocal_ipaddr2;
	uint16_t	ulLocal_ipaddr3;
	uint16_t	ulLocal_ipaddr4;
	uint16_t	ulLocal_ipwg1;
	uint16_t	ulLocal_ipwg2;
	uint16_t	ulLocal_ipwg3;
	uint16_t	ulLocal_ipwg4;
	
	uint16_t	usLocal_rs485_ch1_addr;
	uint16_t	usLocal_rs485_ch2_addr;

	uint16_t	usDc_Voltage_set;
	int16_t		sDc_Current_set;
	int16_t		sDc_Power_set;
	int16_t		sAc_activePower_set;
	int16_t		sAc_reactivePower_set;
	uint16_t	usInvert_Voltage_set;
	uint16_t	usInvert_Frequ_set;

	uint16_t	usLoop_dcVoltage_KP;
	uint16_t	usLoop_dcVoltage_KI;

	uint16_t	usLoop_LsCurrent_KP;
	uint16_t	usLoop_LsCurrent_KI;

	uint16_t	usLoop_dcBalenceVoltage_KP;
	uint16_t	usLoop_dcBalenceVoltage_KI;

	uint16_t	usLoop_acVoltage_KP;
	uint16_t	usLoop_acVoltage_KI;

	uint16_t	usLoop_dccomponentVoltage_KP;
	uint16_t	usLoop_dccomponentVoltage_KI;

	uint16_t	usLoop_Power_KP;
	uint16_t	usLoop_Power_KI;

	uint16_t	usLoop_acRms_KP;
	uint16_t	usLoop_acRms_KI;

	uint16_t	usMask_warm;
	uint16_t	usMask_err;
	
}Set_Para_dt;


/*param usDebug_cmd define*/
#define DEBUG_CMD_REAL	0X01
#define DEBUG_CMD_CALI	0X02

#define AHEAD_GRP_NUM	400
#define AHEAD_GRP_NUM_1 399



typedef struct
{
	uint16_t	usDebug_cmd;	
	uint16_t	usData1_cache_addr;
	uint16_t	usData2_cache_addr;
	uint16_t	usData3_cache_addr;
	uint16_t	usData4_cache_addr;
	uint16_t	usData5_cache_addr;
	uint16_t	usData6_cache_addr;
}Debug_Para_dt;



typedef struct
{
	Real_Inst_dt 	Inst_data;		//ɶʵʱ˲ʱֵɲʾ
	Real_Value1_dt 	Value1_data;	//ɶЧֵ̨ʾʵʱ
	Real_Value2_dt 	Value2_data;	//ɶЧֵ̨ʾʵʱ
	
	Set_Para_dt 	Set_Para;		//ɶдƲ			
	Calib_Para_dt 	Calib_Para; 	//ɶд־ֵ
		
	Debug_Para_dt 	Debug_Para;		//ɶдοƼ
}Sys_dt_t;


struct PLLCALCULATE
{
	float32  f32Valpha; 		// Input: Reference input
	float32  f32Vbeta;			// Input: Feedback input
	float32  f32Vd; 	//
	float32  f32Vq; 		// Parameter: Proportional gain
	float32  f32VdForward;		//
	float32  f32VqForward;			// Parameter: Proportional gain
	float32  f32Vd_Pos;
	float32  f32Vq_Pos;
	float32  f32Vd_Neg;
	float32  f32Vq_Neg;
	float32  f32VNeg;
	float32  f32VqErrOld;			// Variable: Error //Variable: Proportional output
	float32  f32VqErrNew;			// Variable: Error //Variable: Integral output
	float32  f32PLLStep;
	float32  f32ThetaStep;		// Parameter: Minimum output
	float32  f32Theta;			// Output: PID output
										
	float32  SinTheta;		// Variable: Saturated difference
	float32  CosTheta;			// Parameter: Integral gain
															
	float32  f32ITheta; 		// Output: PID output
	float32  ISinTheta; 	// Variable: Saturated difference
	float32  ICosTheta; 		// Parameter: Integral gain
	float32  AIDeltaTheta;			// Parameter: Integral gain
};




#define LIMIT(Var,Max,Min)	{(Var)=((Var)>=(Max))?(Max):(Var);(Var)=((Var)<=(Min))?(Min):(Var);}


typedef struct
{
	// Kp Ki of  Id
	float32 nKp;
	float32 nKi;
	float32 nKc;


	// the Id Iq refrence and Feedback
	float32 nPosIdRef, nPosIqRef;
	float32 nPosIdFeedBack, nPosIqFeedBack;
	float32 nNegIdRef, nNegIqRef;
	float32 nNegIdFeedBack, nNegIqFeedBack;
	
	// the Error of Id and Iq Control Loop
	float32 nPosIdErr;
	float32 nPosIqErr;
	float32 nNegIdErr;
	float32 nNegIqErr;


	// the Integration Control of Id and Iq 
	float32 unPosIdIntgReg;
	float32 unPosIqIntgReg;
	// the Limit Control Value of integration Control
	float32 nPosIdIntgRegLmt;
	float32 nPosIqIntgRegLmt;
	float32 unNegIdIntgReg;
	float32 unNegIqIntgReg;
	// the Limit Control Value of integration Control
	float32 nNegIdIntgRegLmt;
	float32 nNegIqIntgRegLmt;


	// the PI Regulation of Id and Iq
	float32 nPosIdPIRegOriginal;
	float32 nPosIdPIReg;
	float32 nPosIdPIRegErr;
	float32 nNegIdPIRegOriginal;
	float32 nNegIdPIReg;
	float32 nNegIdPIRegErr;
	
	float32 nPosIqPIRegOriginal;
	float32 nPosIqPIReg;
	float32 nPosIqPIRegErr;
	// the Limit Control Value of PI Control
	float32 nPosIdPIRegLmt;
	float32 nPosIqPIRegLmt;
	float32 nNegIqPIRegOriginal;
	float32 nNegIqPIReg;
	float32 nNegIqPIRegErr;
	// the Limit Control Value of PI Control
	float32 nNegIdPIRegLmt;
	float32 nNegIqPIRegLmt;
	
	//
	float32 nPosDDeco;
	float32 nPosQDeco;
	float32 nNegDDeco;
	float32 nNegQDeco;
	float32 nPosUdRef;
	float32 nPosUqRef;
	float32 nNegUdRef;
	float32 nNegUqRef;	
	// the new Reference of Id and Iq

	// the Limit Control Value of Ud and Uq
	float32 nPosUdRefLmt;
	float32 nPosUqRefLmt;

	// the Limit Control Value of Ud and Uq
	float32 nNegUdRefLmt;
	float32 nNegUqRefLmt;


	float32 nPosUd , nPosUq;
	float32 nNegUd , nNegUq;
	// the Id Iq refrence and Feedback
	float32 nPosUdFilter, nPosUqFilter;
	float32 nNegUdFilter, nNegUqFilter;

	float32 nPosId , nPosIq;
	float32 nNegId , nNegIq;
	// the Id Iq refrence and Feedback
	float32 nPosIdFilter, nPosIqFilter;
	float32 nNegIdFilter, nNegIqFilter;

}TCurrCtrl;

typedef struct
{
	
	float32 nKp;
	float32 nKi;
	float32 nKc;

	float32 nBusVolRef;
	float32 nBusVolFeedBack;
	float32 nBusVolErr;
 	float32 unBusVolIntgReg;

	float32 nBusVolIntgRegLmt;

	float32 nBusVolPIRegOriginal;
	float32 nBusVolPIReg;
	float32 nBusVolPIRegErr;

	float32 nBusVolPIRegLmt;
}TBusCtrl;

typedef struct
{
	float32 fCurrIdPos;
	float32 fCurrIqPos;
	float32 fCurrIdNeg;
	float32 fCurrIqNeg;

	float32 fVoltIdPos;
	float32 fVoltIqPos;
	float32 fVoltIdNeg;
	float32 fVoltIqNeg;
}TPosNegData;


void vRoutine_init(void);
void vRoutine(void);


#endif 
