MEMORY
{
   /* BEGIN is used for the "boot to Flash" bootloader mode   */

   BOOT_RSVD       : origin = 0x000002, length = 0x000121     /* Part of M0, BOOT rom will use this for stack */
   RAMM0           	: origin = 0x000123, length = 0x0002DD
   RAMM1           : origin = 0x000400, length = 0x000400     /* on-chip RAM block M1 */

   
   RAMLS03			: origin = 0x008000, length = 0x002000
   RAMLS45          : origin = 0x00A000, length = 0x001000
   RAMD01           : origin = 0x00B000, length = 0x001000
   /*
	   RAMLS0           : origin = 0x008000, length = 0x000800
	   RAMLS1           : origin = 0x008800, length = 0x000800
	   RAMLS2           : origin = 0x009000, length = 0x000800
	   RAMLS3           : origin = 0x009800, length = 0x000800
	   RAMLS4           : origin = 0x00A000, length = 0x000800
	   RAMLS5           : origin = 0x00A800, length = 0x000800
	   RAMD0            : origin = 0x00B000, length = 0x000800
	   RAMD1            : origin = 0x00B800, length = 0x000800
   */
   RAMGS05            : origin = 0x00C000, length = 0x006000
   RAMGS610           : origin = 0x012000, length = 0x005000
   RAMGS1115          : origin = 0x017000, length = 0x005000
   /*
       RAMGS0           : origin = 0x00C000, length = 0x001000
	   RAMGS1           : origin = 0x00D000, length = 0x001000
	   RAMGS2           : origin = 0x00E000, length = 0x001000
	   RAMGS3           : origin = 0x00F000, length = 0x001000
	   RAMGS4           : origin = 0x010000, length = 0x001000
	   RAMGS5           : origin = 0x011000, length = 0x001000
	   RAMGS6           : origin = 0x012000, length = 0x001000
	   RAMGS7           : origin = 0x013000, length = 0x001000
	   RAMGS8           : origin = 0x014000, length = 0x001000
	   RAMGS9           : origin = 0x015000, length = 0x001000
	   RAMGS10          : origin = 0x016000, length = 0x001000
	   RAMGS11          : origin = 0x017000, length = 0x001000
	   RAMGS12          : origin = 0x018000, length = 0x001000
	   RAMGS13          : origin = 0x019000, length = 0x001000
	   RAMGS14          : origin = 0x01A000, length = 0x001000
	   RAMGS15          : origin = 0x01B000, length = 0x001000
   */
   PROGRAM_BOOT  	: origin = 0x080000, length = 0x008000	//bootload
   APP_VER			: origin = 0x088000, length = 0x000010
   BEGIN            : origin = 0x088010, length = 0x000004
   PROGRAM_A		: origin = 0x088020, length = 0x00FFE0
   PROGRAM_B		: origin = 0x098000, length = 0x010000
   PROGRAM_C		: origin = 0x0A8000, length = 0x008000
   PROGRAM_D		: origin = 0x0B0000, length = 0x008000
   PROGRAM_REV		: origin = 0x0B8000, length = 0x006000
   APP_CHECK	    : origin = 0x0BE000, length = 0x000004	//Section N
   /*
	   FLASH0           : origin = 0x080002, length = 0x001FFE
	   FLASH1           : origin = 0x082000, length = 0x002000
	   FLASH2           : origin = 0x084000, length = 0x002000
	   FLASH3           : origin = 0x086000, length = 0x002000
	   FLASH4           : origin = 0x088000, length = 0x008000
	   FLASH5           : origin = 0x090000, length = 0x008000
	   FLASH6           : origin = 0x098000, length = 0x008000
	   FLASH7           : origin = 0x0A0000, length = 0x008000
	   FLASH8           : origin = 0x0A8000, length = 0x008000
	   FLASH9           : origin = 0x0B0000, length = 0x008000
	   FLASH10          : origin = 0x0B8000, length = 0x002000
	   FLASH11          : origin = 0x0BA000, length = 0x002000
	   FLASH12          : origin = 0x0BC000, length = 0x002000
	   FLASH13          : origin = 0x0BE000, length = 0x001FF0
   */

   CANA_MSG_RAM    : origin = 0x049000, length = 0x000800
   CANB_MSG_RAM    : origin = 0x04B000, length = 0x000800
   
   CPU2TOCPU1RAM   : origin = 0x03F800, length = 0x000400
   CPU1TOCPU2RAM   : origin = 0x03FC00, length = 0x000400

   RESET            : origin = 0x3FFFC0, length = 0x000002
}

SECTIONS
{
   codestart           : > BEGIN, ALIGN(4)
   .text               : >> PROGRAM_B | PROGRAM_C , ALIGN(4)
   .cinit              : > PROGRAM_A, ALIGN(4)
   .switch             : > PROGRAM_A, ALIGN(4)
   .reset              : > RESET, TYPE = DSECT /* not used, */
   .stack              : > RAMLS03
   /* IMPORTANT: The FreeRTOS statically allocated stack should be allocated to this section only */
   .freertosStaticStack  : >> RAMD01
   /* IMPORTANT: The FreeRTOS heap should be allocated to this section only as the C28x stack
      memory can be allocated in the lower 64k RAM memory only. */
   .freertosHeap         : > RAMLS45

   .init_array      : > PROGRAM_A, ALIGN(4)
   .bss             : > RAMGS05
   .bss:output      : > RAMGS05
   .bss:cio         : > RAMGS05
   .data            : > RAMGS05
   .sysmem          : > RAMGS610
   /* Initalized sections go in Flash */
   .const           : > PROGRAM_D, ALIGN(4)

//   SHARERAMGS0		: > RAMGS1115
//   SHARERAMGS1		: > RAMGS1115
//   SHARERAMGS2		: > RAMGS1115
   ramm0 : > RAMM0, type=NOINIT
   ramm1 : > RAMM1, type=NOINIT

   MSGRAM_CPU1_TO_CPU2 : > CPU1TOCPU2RAM, type=NOINIT
   MSGRAM_CPU2_TO_CPU1 : > CPU2TOCPU1RAM, type=NOINIT

   AppVer			: > APP_VER
   AppCheck			: > APP_CHECK

  .TI.ramfunc : {} LOAD = PROGRAM_B,
					RUN = RAMGS1115,
                    LOAD_START(RamfuncsLoadStart),
                    LOAD_SIZE(RamfuncsLoadSize),
                    LOAD_END(RamfuncsLoadEnd),
                    RUN_START(RamfuncsRunStart),
                    RUN_SIZE(RamfuncsRunSize),
                    RUN_END(RamfuncsRunEnd),
                    ALIGN(8)

}
/*
//===========================================================================
// End of file.
//===========================================================================
*/
