#ifndef USER_ADC_H_
#define USER_ADC_H_

#include "driverlib.h"
#include "F28x_Project.h"
#include "sysclock_device.h"

#ifndef ONE_MICRO_SEC
#define ONE_MICRO_SEC ((float32_t)0.000001)
#endif

#ifndef ONE_NANO_SEC
#define ONE_NANO_SEC ((float32_t)0.000000001)
#endif

//
// Device Related Defines
//
//#define CONF_CPU_SYS_CLOCK_FREQ_HZ ((float32_t)200*1000000)
//#define CONF_PWMSYSCLOCK_FREQ_HZ ((float32_t)100*1000000)
//#define CONF_ECAPSYSCLOCK_FREQ_HZ	((float32_t)200*1000000)

//
//ADC Related
//
#define CONF_ADC_PWM_TRIG_SOURCE     	ADC_TRIGGER_EPWM1_SOCA
#define CONF_ADC_CONV_TIME       		((float32_t)0.000000210)

#define CONF_ACQPS_SYS_CLKS ((float32_t)151.0 * ONE_NANO_SEC * CONF_CPU_SYS_CLOCK_FREQ_HZ)


#define CONF_VINV_C_ADC_BASE 			ADCA_BASE
#define CONF_VINV_C_ADC_PIN          	ADC_CH_ADCIN3
#define CONF_VINV_C_ADC_SOC_NO        	ADC_SOC_NUMBER0
#define CONF_VINV_C_READ 				ADC_readResult(ADCARESULT_BASE, CONF_VINV_C_ADC_SOC_NO)

#define CONF_VINV_B_ADC_BASE 			ADCB_BASE
#define CONF_VINV_B_ADC_PIN          	ADC_CH_ADCIN0
#define CONF_VINV_B_ADC_SOC_NO        	ADC_SOC_NUMBER0
#define CONF_VINV_B_READ 				ADC_readResult(ADCBRESULT_BASE, CONF_VINV_B_ADC_SOC_NO)

#define CONF_VINV_A_ADC_BASE 			ADCD_BASE
#define CONF_VINV_A_ADC_PIN          	ADC_CH_ADCIN3
#define CONF_VINV_A_ADC_SOC_NO        	ADC_SOC_NUMBER0
#define CONF_VINV_A_READ 				ADC_readResult(ADCDRESULT_BASE, CONF_VINV_A_ADC_SOC_NO)


#define CONF_IINV_MC_ADC_BASE 			ADCA_BASE
#define CONF_IINV_MC_ADC_PIN          	ADC_CH_ADCIN4
#define CONF_IINV_MC_ADC_SOC_NO        	ADC_SOC_NUMBER1
#define CONF_IINV_MC_READ 				ADC_readResult(ADCARESULT_BASE, CONF_IINV_MC_ADC_SOC_NO)

#define CONF_IINV_MB_ADC_BASE 			ADCB_BASE
#define CONF_IINV_MB_ADC_PIN          	ADC_CH_ADCIN14
#define CONF_IINV_MB_ADC_SOC_NO        	ADC_SOC_NUMBER1
#define CONF_IINV_MB_READ 				ADC_readResult(ADCBRESULT_BASE, CONF_IINV_MB_ADC_SOC_NO)

#define CONF_IINV_MA_ADC_BASE 			ADCD_BASE
#define CONF_IINV_MA_ADC_PIN          	ADC_CH_ADCIN2
#define CONF_IINV_MA_ADC_SOC_NO        	ADC_SOC_NUMBER1
#define CONF_IINV_MA_READ 				ADC_readResult(ADCDRESULT_BASE, CONF_IINV_MA_ADC_SOC_NO)


#define CONF_IINV_FA_ADC_BASE 			ADCA_BASE
#define CONF_IINV_FA_ADC_PIN          	ADC_CH_ADCIN2
#define CONF_IINV_FA_ADC_SOC_NO        	ADC_SOC_NUMBER2
#define CONF_IINV_FA_READ 				ADC_readResult(ADCARESULT_BASE, CONF_IINV_FA_ADC_SOC_NO)

#define CONF_IINV_FB_ADC_BASE 			ADCB_BASE
#define CONF_IINV_FB_ADC_PIN          	ADC_CH_ADCIN2
#define CONF_IINV_FB_ADC_SOC_NO        	ADC_SOC_NUMBER2
#define CONF_IINV_FB_READ 				ADC_readResult(ADCBRESULT_BASE, CONF_IINV_FB_ADC_SOC_NO)

#define CONF_IINV_FC_ADC_BASE 			ADCD_BASE
#define CONF_IINV_FC_ADC_PIN          	ADC_CH_ADCIN0
#define CONF_IINV_FC_ADC_SOC_NO        	ADC_SOC_NUMBER2
#define CONF_IINV_FC_READ 				ADC_readResult(ADCDRESULT_BASE, CONF_IINV_FC_ADC_SOC_NO)


#define CONF_IGRID_C_ADC_BASE 			ADCA_BASE
#define CONF_IGRID_C_ADC_PIN          	ADC_CH_ADCIN5
#define CONF_IGRID_C_ADC_SOC_NO        	ADC_SOC_NUMBER3
#define CONF_IGRID_C_READ 				ADC_readResult(ADCARESULT_BASE, CONF_IGRID_C_ADC_SOC_NO)

#define CONF_IGRID_B_ADC_BASE 			ADCB_BASE
#define CONF_IGRID_B_ADC_PIN          	ADC_CH_ADCIN3
#define CONF_IGRID_B_ADC_SOC_NO        	ADC_SOC_NUMBER3
#define CONF_IGRID_B_READ 				ADC_readResult(ADCBRESULT_BASE, CONF_IGRID_B_ADC_SOC_NO)

#define CONF_IGRID_A_ADC_BASE 			ADCD_BASE
#define CONF_IGRID_A_ADC_PIN          	ADC_CH_ADCIN4
#define CONF_IGRID_A_ADC_SOC_NO         ADC_SOC_NUMBER3
#define CONF_IGRID_A_READ 				ADC_readResult(ADCDRESULT_BASE, CONF_IGRID_A_ADC_SOC_NO)



#define CONF_U88CS_ADC_BASE 			ADCA_BASE
#define CONF_U88CS_ADC_PIN          	ADC_CH_ADCIN0
#define CONF_U88CS_ADC_SOC_NO        	ADC_SOC_NUMBER4
#define CONF_U88CS_READ 				ADC_readResult(ADCARESULT_BASE, CONF_U88CS_ADC_SOC_NO)

#define CONF_U87CS_ADC_BASE 			ADCB_BASE
#define CONF_U87CS_ADC_PIN          	ADC_CH_ADCIN1
#define CONF_U87CS_ADC_SOC_NO        	ADC_SOC_NUMBER4
#define CONF_U87CS_READ 				ADC_readResult(ADCBRESULT_BASE, CONF_U87CS_ADC_SOC_NO)


#define CONF_VBUS_ADC_BASE 				ADCD_BASE
#define CONF_VBUS_ADC_PIN          		ADC_CH_ADCIN1
#define CONF_VBUS_ADC_SOC_NO        	ADC_SOC_NUMBER4
#define CONF_VBUS_READ 					ADC_readResult(ADCDRESULT_BASE, CONF_VBUS_ADC_SOC_NO)


#define CONF_U43CS_ADC_BASE 			ADCC_BASE
#define CONF_U43CS_ADC_PIN          	ADC_CH_ADCIN15
#define CONF_U43CS_ADC_SOC_NO        	ADC_SOC_NUMBER0
#define CONF_U43CS_READ 				ADC_readResult(ADCCRESULT_BASE, CONF_U43CS_ADC_SOC_NO)

#define CONF_TEMP_ADC_BASE 				ADCC_BASE
#define CONF_TEMP_ADC_PIN          		ADC_CH_ADCIN3
#define CONF_TEMP_ADC_SOC_NO        	ADC_SOC_NUMBER1
#define CONF_TEMP_READ 					ADC_readResult(ADCCRESULT_BASE, CONF_TEMP_ADC_SOC_NO)



#define CONF_PROTECTION_ENABLED 1
#define CONF_PROTECTION_DISABLED 0
#define CONF_PROTECTION 		CONF_PROTECTION_ENABLED


#define CONF_IINV_MAX_SENSE_AMPS ((float32_t)10)		//ûʹ
#define CONF_IINV_TRIP_LIMIT_AMPS ((float32_t)1000.0f)	//ֱ     1000->100A 

#define CONF_IINV_MA_CMPSS_BASE 		CMPSS2_BASE
#define CONF_IINV_MA_XBAR_MUX 			XBAR_MUX02
#define CONF_IINV_MA_XBAR_MUX_VAL 		XBAR_EPWM_MUX02_CMPSS2_CTRIPH_OR_L
#define CONF_IINV_MA_XBAR_FLAG1 		XBAR_INPUT_FLG_CMPSS2_CTRIPL
#define CONF_IINV_MA_XBAR_FLAG2 		XBAR_INPUT_FLG_CMPSS2_CTRIPH

#define CONF_IINV_MB_CMPSS_BASE 		CMPSS4_BASE
#define CONF_IINV_MB_XBAR_MUX 			XBAR_MUX06
#define CONF_IINV_MB_XBAR_MUX_VAL 		XBAR_EPWM_MUX06_CMPSS4_CTRIPH_OR_L
#define CONF_IINV_MB_XBAR_FLAG1 		XBAR_INPUT_FLG_CMPSS4_CTRIPL
#define CONF_IINV_MB_XBAR_FLAG2 		XBAR_INPUT_FLG_CMPSS4_CTRIPH

#define CONF_IINV_MC_CMPSS_BASE 		CMPSS8_BASE
#define CONF_IINV_MC_XBAR_MUX 			XBAR_MUX14
#define CONF_IINV_MC_XBAR_MUX_VAL 		XBAR_EPWM_MUX14_CMPSS8_CTRIPH_OR_L
#define CONF_IINV_MC_XBAR_FLAG1 		XBAR_INPUT_FLG_CMPSS8_CTRIPL
#define CONF_IINV_MC_XBAR_FLAG2 		XBAR_INPUT_FLG_CMPSS8_CTRIPH

static inline bool HAL_get_iInvA_overCurrentFlag(void)
{
    return(XBAR_getInputFlagStatus(CONF_IINV_MA_XBAR_FLAG1) ||
           XBAR_getInputFlagStatus(CONF_IINV_MA_XBAR_FLAG2));
}

static inline bool HAL_get_iInvB_overCurrentFlag(void)
{
    return(XBAR_getInputFlagStatus(CONF_IINV_MB_XBAR_FLAG1) ||
           XBAR_getInputFlagStatus(CONF_IINV_MB_XBAR_FLAG2));
}

static inline bool HAL_get_iInvC_overCurrentFlag(void)
{
    return(XBAR_getInputFlagStatus(CONF_IINV_MC_XBAR_FLAG1) ||
           XBAR_getInputFlagStatus(CONF_IINV_MC_XBAR_FLAG2));
}

static inline void HAL_clearAllFaultFlags(void)
{

    XBAR_clearInputFlag(CONF_IINV_MA_XBAR_FLAG1);
    XBAR_clearInputFlag(CONF_IINV_MA_XBAR_FLAG2);
    XBAR_clearInputFlag(CONF_IINV_MB_XBAR_FLAG1);
    XBAR_clearInputFlag(CONF_IINV_MB_XBAR_FLAG2);
    XBAR_clearInputFlag(CONF_IINV_MC_XBAR_FLAG1);
    XBAR_clearInputFlag(CONF_IINV_MC_XBAR_FLAG2);

}

void HAL_setupADC(void);
void HAL_setupBoardProtection(void);


#endif
