#include "ecap_device.h"
#include "routing.h"
//__interrupt void ecap1_isr(void);
//extern Sys_dt_t rout_data;

void vEcapDeviceInit(void)
{
	SysCtl_enablePeripheral(CONF_ECAP_APWM_CLKE);
	SysCtl_enablePeripheral(CONF_ECAP_FAN1_CLKE);
	SysCtl_enablePeripheral(CONF_ECAP_FAN2_CLKE);
	SysCtl_enablePeripheral(CONF_ECAP_FAN3_CLKE);

	XBAR_setOutputMuxConfig(XBAR_OUTPUT4, XBAR_OUT_MUX00_ECAP1_OUT);
    XBAR_enableOutputMux(XBAR_OUTPUT4, XBAR_MUX00);
    GPIO_setPadConfig(27, GPIO_PIN_TYPE_STD);
    GPIO_setPinConfig(GPIO_27_OUTPUTXBAR4);

	ECAP_stopCounter(CONF_ECAP_APWM_BASE);
    ECAP_enableAPWMMode(CONF_ECAP_APWM_BASE);
    ECAP_setAPWMPeriod(CONF_ECAP_APWM_BASE, CONF_ECAP_APWM_PERIOD_TICKS);
    ECAP_setAPWMCompare(CONF_ECAP_APWM_BASE, CONF_ECAP_APWM_INIT_DUTY_TICKS);
    ECAP_clearInterrupt(CONF_ECAP_APWM_BASE, (ECAP_ISR_SOURCE_CAPTURE_EVENT_1  |
                                     ECAP_ISR_SOURCE_CAPTURE_EVENT_2  |
                                     ECAP_ISR_SOURCE_CAPTURE_EVENT_3  |
                                     ECAP_ISR_SOURCE_CAPTURE_EVENT_4  |
                                     ECAP_ISR_SOURCE_COUNTER_OVERFLOW |
                                     ECAP_ISR_SOURCE_COUNTER_PERIOD   |
                                     ECAP_ISR_SOURCE_COUNTER_COMPARE));
    ECAP_startCounter(CONF_ECAP_APWM_BASE);

	XBAR_setInputPin(XBAR_INPUT8, GPIO_ECAP_FAN1_PIN);
    GPIO_setPinConfig(GPIO_24_GPIO24);
    GPIO_setDirectionMode(GPIO_ECAP_FAN1_PIN, GPIO_DIR_MODE_IN);
    GPIO_setQualificationMode(GPIO_ECAP_FAN1_PIN, GPIO_QUAL_ASYNC);

	XBAR_setInputPin(XBAR_INPUT9, GPIO_ECAP_FAN2_PIN);
    GPIO_setPinConfig(GPIO_75_GPIO75);
    GPIO_setDirectionMode(GPIO_ECAP_FAN2_PIN, GPIO_DIR_MODE_IN);
    GPIO_setQualificationMode(GPIO_ECAP_FAN2_PIN, GPIO_QUAL_ASYNC);

	XBAR_setInputPin(XBAR_INPUT10, GPIO_ECAP_FAN3_PIN);
    GPIO_setPinConfig(GPIO_26_GPIO26);
    GPIO_setDirectionMode(GPIO_ECAP_FAN3_PIN, GPIO_DIR_MODE_IN);
    GPIO_setQualificationMode(GPIO_ECAP_FAN3_PIN, GPIO_QUAL_ASYNC);



	ECAP_disableTimeStampCapture(CONF_ECAP_FAN1_BASE);	
	ECAP_stopCounter(CONF_ECAP_FAN1_BASE);
	ECAP_setCaptureMode(CONF_ECAP_FAN1_BASE, ECAP_ONE_SHOT_CAPTURE_MODE, ECAP_EVENT_4);
	ECAP_setEventPolarity(CONF_ECAP_FAN1_BASE, ECAP_EVENT_1, ECAP_EVNT_RISING_EDGE);
    ECAP_setEventPolarity(CONF_ECAP_FAN1_BASE, ECAP_EVENT_2, ECAP_EVNT_RISING_EDGE);
	ECAP_setEventPolarity(CONF_ECAP_FAN1_BASE, ECAP_EVENT_3, ECAP_EVNT_RISING_EDGE);
    ECAP_setEventPolarity(CONF_ECAP_FAN1_BASE, ECAP_EVENT_4, ECAP_EVNT_RISING_EDGE);
	ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN1_BASE, ECAP_EVENT_1);
    ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN1_BASE, ECAP_EVENT_2);
	ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN1_BASE, ECAP_EVENT_3);
    ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN1_BASE, ECAP_EVENT_4);
	ECAP_disableLoadCounter(CONF_ECAP_FAN1_BASE);
    ECAP_setSyncOutMode(CONF_ECAP_FAN1_BASE, ECAP_SYNC_OUT_DISABLED);
	ECAP_enableTimeStampCapture(CONF_ECAP_FAN1_BASE);	
	ECAP_startCounter(CONF_ECAP_FAN1_BASE);
	ECAP_reArm(CONF_ECAP_FAN1_BASE);
	ECAP_enableTimeStampCapture(CONF_ECAP_FAN1_BASE);


	ECAP_disableTimeStampCapture(CONF_ECAP_FAN2_BASE);	
	ECAP_stopCounter(CONF_ECAP_FAN2_BASE);
	ECAP_setCaptureMode(CONF_ECAP_FAN2_BASE, ECAP_ONE_SHOT_CAPTURE_MODE, ECAP_EVENT_4);
	ECAP_setEventPolarity(CONF_ECAP_FAN2_BASE, ECAP_EVENT_1, ECAP_EVNT_RISING_EDGE);
    ECAP_setEventPolarity(CONF_ECAP_FAN2_BASE, ECAP_EVENT_2, ECAP_EVNT_RISING_EDGE);
	ECAP_setEventPolarity(CONF_ECAP_FAN2_BASE, ECAP_EVENT_3, ECAP_EVNT_RISING_EDGE);
    ECAP_setEventPolarity(CONF_ECAP_FAN2_BASE, ECAP_EVENT_4, ECAP_EVNT_RISING_EDGE);
	ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN2_BASE, ECAP_EVENT_1);
    ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN2_BASE, ECAP_EVENT_2);
	ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN2_BASE, ECAP_EVENT_3);
    ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN2_BASE, ECAP_EVENT_4);
	ECAP_disableLoadCounter(CONF_ECAP_FAN2_BASE);
    ECAP_setSyncOutMode(CONF_ECAP_FAN2_BASE, ECAP_SYNC_OUT_DISABLED);
	ECAP_enableTimeStampCapture(CONF_ECAP_FAN2_BASE);	
	ECAP_startCounter(CONF_ECAP_FAN2_BASE);
	ECAP_reArm(CONF_ECAP_FAN2_BASE);
	ECAP_enableTimeStampCapture(CONF_ECAP_FAN2_BASE);

	ECAP_disableTimeStampCapture(CONF_ECAP_FAN3_BASE);	
	ECAP_stopCounter(CONF_ECAP_FAN3_BASE);
	ECAP_setCaptureMode(CONF_ECAP_FAN3_BASE, ECAP_ONE_SHOT_CAPTURE_MODE, ECAP_EVENT_4);
	ECAP_setEventPolarity(CONF_ECAP_FAN3_BASE, ECAP_EVENT_1, ECAP_EVNT_RISING_EDGE);
    ECAP_setEventPolarity(CONF_ECAP_FAN3_BASE, ECAP_EVENT_2, ECAP_EVNT_RISING_EDGE);
	ECAP_setEventPolarity(CONF_ECAP_FAN3_BASE, ECAP_EVENT_3, ECAP_EVNT_RISING_EDGE);
    ECAP_setEventPolarity(CONF_ECAP_FAN3_BASE, ECAP_EVENT_4, ECAP_EVNT_RISING_EDGE);
	ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN3_BASE, ECAP_EVENT_1);
    ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN3_BASE, ECAP_EVENT_2);
	ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN3_BASE, ECAP_EVENT_3);
    ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN3_BASE, ECAP_EVENT_4);
	ECAP_disableLoadCounter(CONF_ECAP_FAN3_BASE);
    ECAP_setSyncOutMode(CONF_ECAP_FAN3_BASE, ECAP_SYNC_OUT_DISABLED);
	ECAP_enableTimeStampCapture(CONF_ECAP_FAN3_BASE);	
	ECAP_startCounter(CONF_ECAP_FAN3_BASE);
	ECAP_reArm(CONF_ECAP_FAN3_BASE);
	ECAP_enableTimeStampCapture(CONF_ECAP_FAN3_BASE);
	
	//ECAP_enableInterrupt(CONF_ECAP_FAN1_BASE, ECAP_ISR_SOURCE_CAPTURE_EVENT_4);

/*	ECAP_stopCounter(CONF_ECAP_FAN2_BASE);
    ECAP_enableCaptureMode(CONF_ECAP_FAN2_BASE);
	ECAP_setCaptureMode(CONF_ECAP_FAN2_BASE, ECAP_ONE_SHOT_CAPTURE_MODE, ECAP_EVENT_4);
	ECAP_setEventPolarity(CONF_ECAP_FAN2_BASE, ECAP_EVENT_1, ECAP_EVNT_RISING_EDGE);
    ECAP_setEventPolarity(CONF_ECAP_FAN2_BASE, ECAP_EVENT_2, ECAP_EVNT_RISING_EDGE);
	ECAP_setEventPolarity(CONF_ECAP_FAN2_BASE, ECAP_EVENT_3, ECAP_EVNT_RISING_EDGE);
    ECAP_setEventPolarity(CONF_ECAP_FAN2_BASE, ECAP_EVENT_4, ECAP_EVNT_RISING_EDGE);
	ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN2_BASE, ECAP_EVENT_1);
    ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN2_BASE, ECAP_EVENT_2);
	ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN2_BASE, ECAP_EVENT_3);
    ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN2_BASE, ECAP_EVENT_4);
	XBAR_setInputPin(XBAR_INPUT9, GPIO_ECAP_FAN2_PIN);
	ECAP_enableLoadCounter(CONF_ECAP_FAN2_BASE);
    ECAP_setSyncOutMode(CONF_ECAP_FAN2_BASE, ECAP_SYNC_OUT_DISABLED);
    ECAP_startCounter(CONF_ECAP_FAN2_BASE);
    ECAP_enableTimeStampCapture(CONF_ECAP_FAN2_BASE);
    ECAP_reArm(CONF_ECAP_FAN2_BASE);
	//ECAP_enableInterrupt(CONF_ECAP_FAN2_BASE, ECAP_ISR_SOURCE_CAPTURE_EVENT_4);

	ECAP_stopCounter(CONF_ECAP_FAN3_BASE);
    ECAP_enableCaptureMode(CONF_ECAP_FAN3_BASE);
	ECAP_setCaptureMode(CONF_ECAP_FAN3_BASE, ECAP_ONE_SHOT_CAPTURE_MODE, ECAP_EVENT_4);
	ECAP_setEventPolarity(CONF_ECAP_FAN3_BASE, ECAP_EVENT_1, ECAP_EVNT_RISING_EDGE);
    ECAP_setEventPolarity(CONF_ECAP_FAN3_BASE, ECAP_EVENT_2, ECAP_EVNT_RISING_EDGE);
	ECAP_setEventPolarity(CONF_ECAP_FAN3_BASE, ECAP_EVENT_3, ECAP_EVNT_RISING_EDGE);
    ECAP_setEventPolarity(CONF_ECAP_FAN3_BASE, ECAP_EVENT_4, ECAP_EVNT_RISING_EDGE);
	ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN3_BASE, ECAP_EVENT_1);
    ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN3_BASE, ECAP_EVENT_2);
	ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN3_BASE, ECAP_EVENT_3);
    ECAP_enableCounterResetOnEvent(CONF_ECAP_FAN3_BASE, ECAP_EVENT_4);
	XBAR_setInputPin(XBAR_INPUT10, GPIO_ECAP_FAN3_PIN);
	ECAP_enableLoadCounter(CONF_ECAP_FAN3_BASE);
    ECAP_setSyncOutMode(CONF_ECAP_FAN3_BASE, ECAP_SYNC_OUT_DISABLED);
    ECAP_startCounter(CONF_ECAP_FAN3_BASE);
    ECAP_enableTimeStampCapture(CONF_ECAP_FAN3_BASE);
    ECAP_reArm(CONF_ECAP_FAN3_BASE);
	//ECAP_enableInterrupt(CONF_ECAP_FAN3_BASE, ECAP_ISR_SOURCE_CAPTURE_EVENT_4);

*/


}























