#ifndef _ECAP_DEVICE_H_
#define _ECAP_DEVICE_H_

#include "driverlib.h"
#include "F28x_Project.h"
#include "sysclock_device.h"



#define CONF_ECAP_APWM_CLKE SYSCTL_PERIPH_CLK_ECAP1
#define CONF_ECAP_APWM_BASE ECAP1_BASE

#define CONF_ECAP_APWM_FREQ_HZ ((float32_t)2*1000)
#define CONF_ECAP_APWM_PERIOD_TICKS (uint32_t)(CONF_ECAPSYSCLOCK_FREQ_HZ / CONF_ECAP_APWM_FREQ_HZ)


#define CONF_ECAP_APWM_INIT_DUTY ((float32_t)30) //30%
#define CONF_ECAP_APWM_INIT_DUTY_TICKS (uint32_t)(CONF_ECAP_APWM_PERIOD_TICKS*CONF_ECAP_APWM_INIT_DUTY*(float32_t)0.01)






#define CONF_ECAP_FAN1_CLKE 		SYSCTL_PERIPH_CLK_ECAP2
#define CONF_ECAP_FAN1_BASE 		ECAP2_BASE
#define GPIO_ECAP_FAN1_PIN			24


#define CONF_ECAP_FAN2_CLKE 		SYSCTL_PERIPH_CLK_ECAP3
#define CONF_ECAP_FAN2_BASE 		ECAP3_BASE
#define GPIO_ECAP_FAN2_PIN			75		//תٷ


#define CONF_ECAP_FAN3_CLKE 		SYSCTL_PERIPH_CLK_ECAP4
#define CONF_ECAP_FAN3_BASE 		ECAP4_BASE
#define GPIO_ECAP_FAN3_PIN			26		//תٷ



		//תٷ



void vEcapDeviceInit(void);

static inline void HAL_updateFANPWMduty(uint16_t dbVal)
{
	if(dbVal > 100)	dbVal = 100;
	ECAP_setAPWMShadowCompare(CONF_ECAP_APWM_BASE,(uint32_t)(CONF_ECAP_APWM_PERIOD_TICKS * dbVal *(float32_t)0.01));
}



static inline uint16_t HAL_getFAN1TimePerPERIOD(void)
{
	return ECAP_getEventTimeStamp(CONF_ECAP_FAN1_BASE, ECAP_EVENT_2) * 0.001f;
}

static inline uint16_t HAL_getFAN2TimePerPERIOD(void)
{
	return ECAP_getEventTimeStamp(CONF_ECAP_FAN1_BASE, ECAP_EVENT_3)* 0.001f;
}

static inline uint16_t HAL_getFAN3TimePerPERIOD(void)
{
	return ECAP_getEventTimeStamp(CONF_ECAP_FAN1_BASE, ECAP_EVENT_4)* 0.001f;
}

static inline void HAL_Ecap_ReStart(void)
{
	ECAP_reArm(CONF_ECAP_FAN1_BASE);
	ECAP_reArm(CONF_ECAP_FAN2_BASE);
	ECAP_reArm(CONF_ECAP_FAN3_BASE);
}





#endif 


