#ifndef _GPIO_DEVICE_H_
#define _GPIO_DEVICE_H_

#include "driverlib.h"
#include "F28x_Project.h"
#include "led_device.h"

void vGpioDeviceInit(void);

//GPIO outputs U32
#define GPIO_PIN_CD_CS0 	41
#define GPIO_PIN_CD_S0		48
#define GPIO_PIN_CD_S1		49
#define GPIO_PIN_CD_S2		50
#define GPIO_PIN_CD_CS1		51


//GPIO outputs U30 ʰ
#define GPIO_PIN_M_FPC_RELY2	83		//ཻ·̵
#define GPIO_PIN_M_PWR_RELY		82		//ཻԴ̵
#define GPIO_PIN_M_SCR_PWM		81		//ྦྷբPWM ƽ
#define GPIO_PIN_M_SCR_RELY		80		//ྦྷբܶ·Ӵ
#define GPIO_PIN_M_FPC_RELY1	74		//ཻ·̵
#define GPIO_PIN_M_DC_RELY2		79		//ֱӴ
#define GPIO_PIN_M_DC_RELY1		78		//ֱӴ


#define GPIO_PIN_M_PWR_CTR1		67		//Դ1
#define	GPIO_PIN_M_PWR_CTR2		77		//Դ2


//GPIO outputs U31 ʰ
#define GPIO_PIN_F_FPC_RELY2	53		//ཻ·̵
#define GPIO_PIN_F_PWR_RELY		54		//ཻԴ̵
#define GPIO_PIN_F_SCR_PWM		62		//ྦྷբPWM ƽ
#define GPIO_PIN_F_SCR_RELY		40		//ྦྷբܶ·Ӵ
#define GPIO_PIN_F_DC_RELY2		55		//ֱӴ
#define GPIO_PIN_F_DC_RELY1		52		//ֱӴ
#define GPIO_PIN_F_FPC_RELY1	47		//ཻ·̵

#define GPIO_PIN_F_PWR_CTR1		46		//Դ1 ʱδ
#define	GPIO_PIN_F_PWR_CTR2		76		//Դ2 ʱδ


//J7 PIN64
#define GPIO_PIN_LED_ERR		68
#define GPIO_PIN_LED_RUN		44

//δʼ
#define GPIO_PIN_G_FAN_PWM		27		//PWMת
#define GPIO_PIN_G_FAN_SPD1		24		//תٷ
#define GPIO_PIN_G_FAN_SPD2		75		//תٷ
#define GPIO_PIN_G_FAN_SPD3		26		//תٷ


#define GPIO_PIN_ARM_RESET		88		


//GPIO inputs 
//*****************************************************************************
static inline void
vGPIOTurnOff(uint32_t pin)
{
    vGPIOClearPin(pin);
}

static inline void
vGPIOTurnOn(uint32_t pin)
{
    vGPIOSetPin(pin);
}


#define FAN_OUT_H	GpioDataRegs.GPASET.bit.GPIO27=1
#define FAN_OUT_L	GpioDataRegs.GPACLEAR.bit.GPIO27=1

#define M4051U85_CS_ENABLE 			GpioDataRegs.GPBSET.bit.GPIO41=1
#define M4051U85_CS_DISENABLE 		GpioDataRegs.GPBCLEAR.bit.GPIO41=1

#define M4051U86_CS_ENABLE 			GpioDataRegs.GPBSET.bit.GPIO51=1
#define M4051U86_CS_DISENABLE 		GpioDataRegs.GPBCLEAR.bit.GPIO51=1


#define M4051_OUT_U86				{										\
									GpioDataRegs.GPBSET.bit.GPIO51=1;		\
									GpioDataRegs.GPBCLEAR.bit.GPIO41=1;		\
									}

#define M4051_OUT_U85				{										\
									GpioDataRegs.GPBSET.bit.GPIO41=1;		\
									GpioDataRegs.GPBCLEAR.bit.GPIO51=1;		\
									}


//48 49 50
#define M4051_OUT_Y0				{	\
										GpioDataRegs.GPBSET.bit.GPIO50 = 1; 	\
										GpioDataRegs.GPBSET.bit.GPIO49 = 1;	\
										GpioDataRegs.GPBSET.bit.GPIO48 = 1;	\
									}
#define M4051_OUT_Y1				{	\
										GpioDataRegs.GPBSET.bit.GPIO50 = 1; 	\
										GpioDataRegs.GPBSET.bit.GPIO49 = 1;	\
										GpioDataRegs.GPBCLEAR.bit.GPIO48 = 1;		\
									}	
#define M4051_OUT_Y2				{	\
										GpioDataRegs.GPBSET.bit.GPIO50 = 1; 	\
										GpioDataRegs.GPBCLEAR.bit.GPIO49 = 1;		\
										GpioDataRegs.GPBSET.bit.GPIO48 = 1;	\
									}
#define M4051_OUT_Y3				{	\
										GpioDataRegs.GPBSET.bit.GPIO50 = 1; 	\
										GpioDataRegs.GPBCLEAR.bit.GPIO49 = 1;		\
										GpioDataRegs.GPBCLEAR.bit.GPIO48 = 1;		\
									}
#define M4051_OUT_Y4				{	\
										GpioDataRegs.GPBCLEAR.bit.GPIO50 = 1; 	\
										GpioDataRegs.GPBSET.bit.GPIO49 = 1;	\
										GpioDataRegs.GPBSET.bit.GPIO48 = 1;	\
									}
#define M4051_OUT_Y5				{	\
										GpioDataRegs.GPBCLEAR.bit.GPIO50 = 1; 	\
										GpioDataRegs.GPBSET.bit.GPIO49 = 1;	\
										GpioDataRegs.GPBCLEAR.bit.GPIO48 = 1;		\
									}
#define M4051_OUT_Y6				{	\
										GpioDataRegs.GPBCLEAR.bit.GPIO50 = 1; 	\
										GpioDataRegs.GPBCLEAR.bit.GPIO49 = 1;		\
										GpioDataRegs.GPBSET.bit.GPIO48 = 1;	\
									}
#define M4051_OUT_Y7				{	\
										GpioDataRegs.GPBCLEAR.bit.GPIO50 = 1; 	\
										GpioDataRegs.GPBCLEAR.bit.GPIO49 = 1;		\
										GpioDataRegs.GPBCLEAR.bit.GPIO48 = 1;		\
									}


#define M_GRID_RELY_ON				{	\
										GpioDataRegs.GPCSET.bit.GPIO80 = 1;\
										rout_data.Value2_data.usRelay_states |= 0x01;\
									}

#define M_GRID_RELY_OFF				{	\
										GpioDataRegs.GPCCLEAR.bit.GPIO80 = 1;\
										rout_data.Value2_data.usRelay_states &= 0xFFFE;\
									}

#define M_FPC_RELY_M_ON				{	\
										GpioDataRegs.GPCSET.bit.GPIO74 = 1;\
										rout_data.Value2_data.usRelay_states |= 0x10;\
									}

#define M_FPC_RELY_M_OFF			{	\
										GpioDataRegs.GPCCLEAR.bit.GPIO74 = 1;\
										rout_data.Value2_data.usRelay_states &= 0xFFEF;\
									}

#define M_FPC_RELY_HC_ON			{	\
										GpioDataRegs.GPCSET.bit.GPIO83 = 1;\
										rout_data.Value2_data.usRelay_states |= 0x100;\
									}

#define M_FPC_RELY_HC_OFF			{	\
										GpioDataRegs.GPCCLEAR.bit.GPIO83 = 1;\
										rout_data.Value2_data.usRelay_states &= 0xFEFF;\
									}

#define DC_RELY_M_ON				{	\
										GpioDataRegs.GPCSET.bit.GPIO78 = 1;\
										rout_data.Value2_data.usRelay_states |= 0x1000;\
									}

#define DC_RELY_M_OFF				{	\
										GpioDataRegs.GPCCLEAR.bit.GPIO78 = 1;\
										rout_data.Value2_data.usRelay_states &= 0xEFFF;\
									}

#define DC_RELY_HC_ON				{	\
										GpioDataRegs.GPCSET.bit.GPIO79 = 1;\
										rout_data.Value2_data.usRelay_states |= 0x8000;\
									}

#define DC_RELY_HC_OFF				{	\
										GpioDataRegs.GPCCLEAR.bit.GPIO79 = 1;\
										rout_data.Value2_data.usRelay_states &= 0x7FFF;\
									}




#define ARM_RESET_DISABLE			GpioDataRegs.GPCCLEAR.bit.GPIO88 = 1


#define GPIO_ARM_RUN_STATES			72		
#define ARM_RUN_STATES				GpioDataRegs.GPCDAT.bit.GPIO72


#endif
