#ifndef USER_PWM_H_
#define USER_PWM_H_

#include "driverlib.h"
#include "F28x_Project.h"
#include "sysclock_device.h"
#include <stdint.h>


void HAL_disablePWMClkCounting(void);
void HAL_enablePWMClkCounting(void);
void HAL_setupPWM(void);
void HAL_configurePWMUpDwnCnt(uint32_t base1, uint16_t pwm_period_ticks);
void HAL_clearInterrupt(uint16_t pie_group_no);
void HAL_enablePWMInterruptGeneration(uint32_t base,uint16_t cmpc_val);
//void HAL_setupInterrupt(void);


#define CONF_PWM_SWITCHING_FREQ_HZ ((float32_t)20*1000)

#define CONF_PWM_DEADBAND_US ((float32_t)1.0)
#define CONF_PWM_PERIOD_TICKS (CONF_PWMSYSCLOCK_FREQ_HZ / CONF_PWM_SWITCHING_FREQ_HZ)
#define CONF_PWM_DEADBAND_TICKS (int16_t)((float32_t)CONF_PWM_DEADBAND_US *    \
                                          (float32_t)CONF_PWMSYSCLOCK_FREQ_HZ *   \
                                          (float32_t)ONE_MICRO_SEC)


//
// Phase A PWM
//
#define CONF_Q1_Q3_MA_PWM_CLKE	SYSCTL_PERIPH_CLK_EPWM1
#define CONF_Q2_Q4_MA_PWM_CLKE	SYSCTL_PERIPH_CLK_EPWM2

#define CONF_Q1_Q3_A_PWM_BASE EPWM1_BASE
#define CONF_Q2_Q4_A_PWM_BASE EPWM2_BASE

#define CONF_Q1_A_PWM_GPIO 0
#define CONF_Q1_A_PWM_GPIO_PIN_CONFIG GPIO_0_EPWM1A

#define CONF_Q3_A_PWM_GPIO 1
#define CONF_Q3_A_PWM_GPIO_PIN_CONFIG GPIO_1_EPWM1B

#define CONF_Q2_A_PWM_GPIO 2
#define CONF_Q2_A_PWM_GPIO_PIN_CONFIG GPIO_2_EPWM2A

#define CONF_Q4_A_PWM_GPIO 3
#define CONF_Q4_A_PWM_GPIO_PIN_CONFIG GPIO_3_EPWM2B

//
// Phase B PWM
//
#define CONF_Q1_Q3_MB_PWM_CLKE	SYSCTL_PERIPH_CLK_EPWM3
#define CONF_Q2_Q4_MB_PWM_CLKE	SYSCTL_PERIPH_CLK_EPWM4


#define CONF_Q1_Q3_B_PWM_BASE EPWM3_BASE
#define CONF_Q2_Q4_B_PWM_BASE EPWM4_BASE

#define CONF_Q1_B_PWM_GPIO 4
#define CONF_Q1_B_PWM_GPIO_PIN_CONFIG GPIO_4_EPWM3A

#define CONF_Q3_B_PWM_GPIO 5
#define CONF_Q3_B_PWM_GPIO_PIN_CONFIG GPIO_5_EPWM3B

#define CONF_Q2_B_PWM_GPIO 6
#define CONF_Q2_B_PWM_GPIO_PIN_CONFIG GPIO_6_EPWM4A

#define CONF_Q4_B_PWM_GPIO 7
#define CONF_Q4_B_PWM_GPIO_PIN_CONFIG GPIO_7_EPWM4B

//
// Phase C PWM
//
//
//

#define CONF_Q1_Q3_MC_PWM_CLKE	SYSCTL_PERIPH_CLK_EPWM9
#define CONF_Q2_Q4_MC_PWM_CLKE	SYSCTL_PERIPH_CLK_EPWM10

#define CONF_Q1_Q3_C_PWM_BASE EPWM9_BASE
#define CONF_Q2_Q4_C_PWM_BASE EPWM10_BASE

#define CONF_Q1_C_PWM_GPIO 16
#define CONF_Q1_C_PWM_GPIO_PIN_CONFIG GPIO_16_EPWM9A

#define CONF_Q3_C_PWM_GPIO 17
#define CONF_Q3_C_PWM_GPIO_PIN_CONFIG GPIO_17_EPWM9B

#define CONF_Q2_C_PWM_GPIO 18
#define CONF_Q2_C_PWM_GPIO_PIN_CONFIG GPIO_18_EPWM10A

#define CONF_Q4_C_PWM_GPIO 19
#define CONF_Q4_C_PWM_GPIO_PIN_CONFIG GPIO_19_EPWM10B










#define	CNTRL_ISR_FREQ_RATIO		1
#define C28x_ISR1_INTERRUPT_TRIG_PWM_BASE EPWM1_BASE

//
//Power Stage Related Values
//
#define CPU_SYS_CLOCK_FREQ_HZ ((float32_t)200*1000000)
#define PWMSYSCLOCK_FREQ_HZ ((float32_t)100*1000000)	//ϵͳĬһ/2 ԤƵ EPWMCLKDIV
//#define ECAPSYSCLOCK_FREQ_HZ	((float32_t)200*1000000)

void HAL_setupTriggerForADC(uint32_t base);
void HAL_setPinsAsPWM();
void HAL_setupPWMforTrip(uint32_t base);
void InitPwm(void);
void HAL_enablePWMCLK(void)
;



//interrupt void ISR1(void);


#define LSP_CLK_FREQUENCY_HZ ((float32_t)50 * 1000000)
#define C28x_ISR1_INTERRUPT_PIE_GROUP_NO INTERRUPT_ACK_GROUP3
#define C28x_ISR2_INTERRUPT_PIE_GROUP_NO INTERRUPT_CPU_INT14

#define C28x_ISR1_INTERRUPT_TRIG_PWM_BASE EPWM1_BASE
#define C28x_ISR1_INTERRUPT INT_EPWM1


//#define INSTRUMENTATION_ISR_FREQUENCY_HZ ((float32_t)10 * 1000)
//#define C28x_INSTRUMENTATION_INTERRUPT_TRIG_CPUTIMER_BASE CPUTIMER2_BASE
//#define C28x_INSTRUMENTATION_INTERRUPT INT_TIMER2


#define CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_HIGH(m) HWREGH(m + EPWM_O_AQCSFRC) = 0x05;
#define CONF_HAL_AQ_SW_FORCE_PWMXA_DISABLE_PWMxB_DISABLE(m) HWREGH(m + EPWM_O_AQCSFRC) = 0x00;
#define CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_LOW(m) HWREGH(m + EPWM_O_AQCSFRC) = 0x05;//ǿΪ͵ƽ

#pragma FUNC_ALWAYS_INLINE(CONF_HAL_updatePWMDuty)
static inline void CONF_HAL_updatePWMDuty(float32_t dutyA,
                                     float32_t dutyB,
                                     float32_t dutyC)
{
    uint32_t dutyA_ticks, dutyB_ticks, dutyC_ticks;
    dutyA_ticks = (uint32_t)((float32_t)(CONF_PWM_PERIOD_TICKS / 2.0)
                            * fabsf(dutyA));
    dutyB_ticks = (uint32_t)((float32_t)(CONF_PWM_PERIOD_TICKS / 2.0)
                            * fabsf(dutyB));
    dutyC_ticks = (uint32_t)((float32_t)(CONF_PWM_PERIOD_TICKS / 2.0)
                            * fabsf(dutyC));

    //
    // Set PWM outputs
    //
   if(dutyA > 0.0f)
    {


        CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_HIGH(CONF_Q2_Q4_A_PWM_BASE);
        CONF_HAL_AQ_SW_FORCE_PWMXA_DISABLE_PWMxB_DISABLE(CONF_Q1_Q3_A_PWM_BASE);
    }
    else
    {
        CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_HIGH(CONF_Q1_Q3_A_PWM_BASE);
        CONF_HAL_AQ_SW_FORCE_PWMXA_DISABLE_PWMxB_DISABLE(CONF_Q2_Q4_A_PWM_BASE);
    }

    if(dutyB > 0.0f)
    {
        CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_HIGH(CONF_Q2_Q4_B_PWM_BASE);
        CONF_HAL_AQ_SW_FORCE_PWMXA_DISABLE_PWMxB_DISABLE(CONF_Q1_Q3_B_PWM_BASE);
    }
    else
    {
        CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_HIGH(CONF_Q1_Q3_B_PWM_BASE);
        CONF_HAL_AQ_SW_FORCE_PWMXA_DISABLE_PWMxB_DISABLE(CONF_Q2_Q4_B_PWM_BASE);
    }

    if(dutyC > 0.0f)
    {
        CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_HIGH(CONF_Q2_Q4_C_PWM_BASE);
        CONF_HAL_AQ_SW_FORCE_PWMXA_DISABLE_PWMxB_DISABLE(CONF_Q1_Q3_C_PWM_BASE);
    }
    else
    {
        CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_HIGH(CONF_Q1_Q3_C_PWM_BASE);
        CONF_HAL_AQ_SW_FORCE_PWMXA_DISABLE_PWMxB_DISABLE(CONF_Q2_Q4_C_PWM_BASE);
    }


    EPWM_setCounterCompareValue(CONF_Q1_Q3_A_PWM_BASE,
                                EPWM_COUNTER_COMPARE_A,
                                dutyA_ticks);
    EPWM_setCounterCompareValue(CONF_Q2_Q4_A_PWM_BASE,
                                EPWM_COUNTER_COMPARE_A,
                                dutyA_ticks);

    EPWM_setCounterCompareValue(CONF_Q1_Q3_B_PWM_BASE,
                                EPWM_COUNTER_COMPARE_A,
                                dutyB_ticks);
    EPWM_setCounterCompareValue(CONF_Q2_Q4_B_PWM_BASE,
                                EPWM_COUNTER_COMPARE_A,
                                dutyB_ticks);

    EPWM_setCounterCompareValue(CONF_Q1_Q3_C_PWM_BASE,
                               EPWM_COUNTER_COMPARE_A,
                               dutyC_ticks);
    EPWM_setCounterCompareValue(CONF_Q2_Q4_C_PWM_BASE,
                               EPWM_COUNTER_COMPARE_A,
                               dutyC_ticks);
}
							


#pragma FUNC_ALWAYS_INLINE(CONF_HAL_updatePWMDuty_SVPWM)
static inline void CONF_HAL_updatePWMDuty_SVPWM(float32_t dutyA1,float32_t dutyA2,
                                     float32_t dutyB1, float32_t dutyB2,
                                     float32_t dutyC1,float32_t dutyC2)
{
    uint32_t dutyA1_ticks, dutyB1_ticks, dutyC1_ticks;
	uint32_t dutyA2_ticks, dutyB2_ticks, dutyC2_ticks;
    dutyA1_ticks = (uint32_t)((float32_t)(CONF_PWM_PERIOD_TICKS / 2.0)
                            * fabsf(dutyA1));
    dutyB1_ticks = (uint32_t)((float32_t)(CONF_PWM_PERIOD_TICKS / 2.0)
                            * fabsf(dutyB1));
    dutyC1_ticks = (uint32_t)((float32_t)(CONF_PWM_PERIOD_TICKS / 2.0)
                            * fabsf(dutyC1));

	dutyA2_ticks = (uint32_t)((float32_t)(CONF_PWM_PERIOD_TICKS / 2.0)
                            * fabsf(dutyA2));
    dutyB2_ticks = (uint32_t)((float32_t)(CONF_PWM_PERIOD_TICKS / 2.0)
                            * fabsf(dutyB2));
    dutyC2_ticks = (uint32_t)((float32_t)(CONF_PWM_PERIOD_TICKS / 2.0)
                            * fabsf(dutyC2));

    EPWM_setCounterCompareValue(CONF_Q1_Q3_A_PWM_BASE,
                                EPWM_COUNTER_COMPARE_A,
                                dutyA1_ticks);
    EPWM_setCounterCompareValue(CONF_Q2_Q4_A_PWM_BASE,
                                EPWM_COUNTER_COMPARE_A,
                                dutyA2_ticks);

    EPWM_setCounterCompareValue(CONF_Q1_Q3_B_PWM_BASE,
                                EPWM_COUNTER_COMPARE_A,
                                dutyB1_ticks);
    EPWM_setCounterCompareValue(CONF_Q2_Q4_B_PWM_BASE,
                                EPWM_COUNTER_COMPARE_A,
                                dutyB2_ticks);

    EPWM_setCounterCompareValue(CONF_Q1_Q3_C_PWM_BASE,
                               EPWM_COUNTER_COMPARE_A,
                               dutyC1_ticks);
    EPWM_setCounterCompareValue(CONF_Q2_Q4_C_PWM_BASE,
                               EPWM_COUNTER_COMPARE_A,
                               dutyC2_ticks);
}
							



									 
static inline void HAL_updatePWMDeadBand(uint32_t dbVal)
{
		EPWM_setRisingEdgeDelayCount(CONF_Q1_Q3_A_PWM_BASE, dbVal);
		EPWM_setRisingEdgeDelayCount(CONF_Q1_Q3_B_PWM_BASE, dbVal);
		EPWM_setRisingEdgeDelayCount(CONF_Q1_Q3_C_PWM_BASE, dbVal);
	
		EPWM_setRisingEdgeDelayCount(CONF_Q2_Q4_A_PWM_BASE, dbVal);
		EPWM_setRisingEdgeDelayCount(CONF_Q2_Q4_B_PWM_BASE, dbVal);
		EPWM_setRisingEdgeDelayCount(CONF_Q2_Q4_C_PWM_BASE, dbVal);
	
		EPWM_setFallingEdgeDelayCount(CONF_Q1_Q3_A_PWM_BASE, dbVal);
		EPWM_setFallingEdgeDelayCount(CONF_Q1_Q3_B_PWM_BASE, dbVal);
		EPWM_setFallingEdgeDelayCount(CONF_Q1_Q3_C_PWM_BASE, dbVal);
	
		EPWM_setFallingEdgeDelayCount(CONF_Q2_Q4_A_PWM_BASE, dbVal);
		EPWM_setFallingEdgeDelayCount(CONF_Q2_Q4_B_PWM_BASE, dbVal);
		EPWM_setFallingEdgeDelayCount(CONF_Q2_Q4_C_PWM_BASE, dbVal);
}

static inline void CONF_HAL_clearPWMTripFlags(uint32_t base)
{
    EPWM_clearTripZoneFlag(base, (EPWM_TZ_INTERRUPT_OST |
                                      EPWM_TZ_INTERRUPT_CBC |
                                      EPWM_TZ_INTERRUPT_DCAEVT1));
}


static inline void CONF_disablePWM(void)
{
	EPWM_setDeadBandDelayMode(CONF_Q1_Q3_A_PWM_BASE,EPWM_DB_RED,0);
	EPWM_setDeadBandDelayMode(CONF_Q1_Q3_A_PWM_BASE,EPWM_DB_FED,0);

	EPWM_setDeadBandDelayMode(CONF_Q2_Q4_A_PWM_BASE,EPWM_DB_RED,0);
	EPWM_setDeadBandDelayMode(CONF_Q2_Q4_A_PWM_BASE,EPWM_DB_FED,0);

	EPWM_setDeadBandDelayMode(CONF_Q1_Q3_B_PWM_BASE,EPWM_DB_RED,0);
	EPWM_setDeadBandDelayMode(CONF_Q1_Q3_B_PWM_BASE,EPWM_DB_FED,0);

	EPWM_setDeadBandDelayMode(CONF_Q2_Q4_B_PWM_BASE,EPWM_DB_RED,0);
	EPWM_setDeadBandDelayMode(CONF_Q2_Q4_B_PWM_BASE,EPWM_DB_FED,0);

	EPWM_setDeadBandDelayMode(CONF_Q1_Q3_C_PWM_BASE,EPWM_DB_RED,0);
	EPWM_setDeadBandDelayMode(CONF_Q1_Q3_C_PWM_BASE,EPWM_DB_FED,0);

	EPWM_setDeadBandDelayMode(CONF_Q2_Q4_C_PWM_BASE,EPWM_DB_RED,0);
	EPWM_setDeadBandDelayMode(CONF_Q2_Q4_C_PWM_BASE,EPWM_DB_FED,0);

	EPWM_setActionQualifierContSWForceShadowMode(CONF_Q1_Q3_A_PWM_BASE,EPWM_AQ_SW_IMMEDIATE_LOAD);
	EPWM_setActionQualifierContSWForceShadowMode(CONF_Q2_Q4_A_PWM_BASE,EPWM_AQ_SW_IMMEDIATE_LOAD);
	EPWM_setActionQualifierContSWForceShadowMode(CONF_Q1_Q3_B_PWM_BASE,EPWM_AQ_SW_IMMEDIATE_LOAD);
	EPWM_setActionQualifierContSWForceShadowMode(CONF_Q2_Q4_B_PWM_BASE,EPWM_AQ_SW_IMMEDIATE_LOAD);
	EPWM_setActionQualifierContSWForceShadowMode(CONF_Q1_Q3_C_PWM_BASE,EPWM_AQ_SW_IMMEDIATE_LOAD);
	EPWM_setActionQualifierContSWForceShadowMode(CONF_Q2_Q4_C_PWM_BASE,EPWM_AQ_SW_IMMEDIATE_LOAD);
	
	CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_LOW(CONF_Q1_Q3_A_PWM_BASE);
	CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_LOW(CONF_Q2_Q4_A_PWM_BASE);
	CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_LOW(CONF_Q1_Q3_B_PWM_BASE);
	CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_LOW(CONF_Q2_Q4_B_PWM_BASE);
	CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_LOW(CONF_Q1_Q3_C_PWM_BASE);
	CONF_HAL_AQ_SW_FORCE_PWMXA_LOW_PWMxB_LOW(CONF_Q2_Q4_C_PWM_BASE);

	
}

static inline void CONF_enablePWM(void)
{
	EPWM_setDeadBandDelayMode(CONF_Q1_Q3_A_PWM_BASE,EPWM_DB_RED,1);
	EPWM_setDeadBandDelayMode(CONF_Q1_Q3_A_PWM_BASE,EPWM_DB_FED,1);

	EPWM_setDeadBandDelayMode(CONF_Q2_Q4_A_PWM_BASE,EPWM_DB_RED,1);
	EPWM_setDeadBandDelayMode(CONF_Q2_Q4_A_PWM_BASE,EPWM_DB_FED,1);

	EPWM_setDeadBandDelayMode(CONF_Q1_Q3_B_PWM_BASE,EPWM_DB_RED,1);
	EPWM_setDeadBandDelayMode(CONF_Q1_Q3_B_PWM_BASE,EPWM_DB_FED,1);

	EPWM_setDeadBandDelayMode(CONF_Q2_Q4_B_PWM_BASE,EPWM_DB_RED,1);
	EPWM_setDeadBandDelayMode(CONF_Q2_Q4_B_PWM_BASE,EPWM_DB_FED,1);

	EPWM_setDeadBandDelayMode(CONF_Q1_Q3_C_PWM_BASE,EPWM_DB_RED,1);
	EPWM_setDeadBandDelayMode(CONF_Q1_Q3_C_PWM_BASE,EPWM_DB_FED,1);

	EPWM_setDeadBandDelayMode(CONF_Q2_Q4_C_PWM_BASE,EPWM_DB_RED,1);
	EPWM_setDeadBandDelayMode(CONF_Q2_Q4_C_PWM_BASE,EPWM_DB_FED,1);

	EPWM_setActionQualifierContSWForceShadowMode(CONF_Q1_Q3_A_PWM_BASE,EPWM_AQ_SW_SH_LOAD_ON_CNTR_ZERO_PERIOD);
	EPWM_setActionQualifierContSWForceShadowMode(CONF_Q2_Q4_A_PWM_BASE,EPWM_AQ_SW_SH_LOAD_ON_CNTR_ZERO_PERIOD);
	EPWM_setActionQualifierContSWForceShadowMode(CONF_Q1_Q3_B_PWM_BASE,EPWM_AQ_SW_SH_LOAD_ON_CNTR_ZERO_PERIOD);
	EPWM_setActionQualifierContSWForceShadowMode(CONF_Q2_Q4_B_PWM_BASE,EPWM_AQ_SW_SH_LOAD_ON_CNTR_ZERO_PERIOD);
	EPWM_setActionQualifierContSWForceShadowMode(CONF_Q1_Q3_C_PWM_BASE,EPWM_AQ_SW_SH_LOAD_ON_CNTR_ZERO_PERIOD);
	EPWM_setActionQualifierContSWForceShadowMode(CONF_Q2_Q4_C_PWM_BASE,EPWM_AQ_SW_SH_LOAD_ON_CNTR_ZERO_PERIOD);

}


static inline void CONF_clearPWMTripFlags(void)
{
	CONF_HAL_clearPWMTripFlags(CONF_Q1_Q3_A_PWM_BASE);
	CONF_HAL_clearPWMTripFlags(CONF_Q2_Q4_A_PWM_BASE);
	CONF_HAL_clearPWMTripFlags(CONF_Q1_Q3_B_PWM_BASE);
	CONF_HAL_clearPWMTripFlags(CONF_Q2_Q4_B_PWM_BASE);
	CONF_HAL_clearPWMTripFlags(CONF_Q1_Q3_C_PWM_BASE);
	CONF_HAL_clearPWMTripFlags(CONF_Q2_Q4_C_PWM_BASE);
}


#endif
