/*
 * sci_device.h
 *
 *  Created on: 2023122
 *      Author: QA
 */

#ifndef DEVICE_SCI_A_H_
#define DEVICE_SCI_A_H_

#include "driverlib.h"
#include "FreeRTOS.h"

//
// SCI for USB-to-UART adapter on FTDI chip
//

#define DEVICE_GPIO_PIN_SCIRXDA     85U             // GPIO number for SCI RX
#define DEVICE_GPIO_PIN_SCITXDA     84U             // GPIO number for SCI TX
#define DEVICE_GPIO_CFG_SCIRXDA     GPIO_85_SCIRXDA // "pinConfig" for SCI RX
#define DEVICE_GPIO_CFG_SCITXDA     GPIO_84_SCITXDA // "pinConfig" for SCI TX

//
// Function Prototypes
//
void vSciaDeviceInit(uint32_t ulbaud);
uint16_t usSciaRead(uint16_t *dt);
int16_t sSciaWrite(uint16_t *dt, uint16_t lenth);
int16_t sSciaBlockWrite(uint16_t *dt, uint16_t lenth, TickType_t xBlockTime);
uint16_t usSciaBlockRead(uint16_t *buf, TickType_t xBlockTime);

#endif /* DEVICE_SCI_ABCD_H_ */
