/*
 * sci_device.h
 *
 *  Created on: 2023122
 *      Author: QA
 */

#ifndef DEVICE_SCI_B_H_
#define DEVICE_SCI_B_H_

#include "driverlib.h"
#include "FreeRTOS.h"

//
// SCI for USB-to-UART adapter on FTDI chip
//

#define DEVICE_GPIO_PIN_SCIRXDB     87U             // GPIO number for SCI RX
#define DEVICE_GPIO_PIN_SCITXDB     86U             // GPIO number for SCI TX
#define DEVICE_GPIO_CFG_SCIRXDB     GPIO_87_SCIRXDB // "pinConfig" for SCI RX
#define DEVICE_GPIO_CFG_SCITXDB     GPIO_86_SCITXDB // "pinConfig" for SCI TX

//
// Function Prototypes
//
void vScibDeviceInit(uint32_t ulbaud);
uint16_t usScibRead(uint16_t *dt);
int16_t sScibWrite(uint16_t *dt, uint16_t lenth);
int16_t sScibBlockWrite(uint16_t *dt, uint16_t lenth, TickType_t xBlockTime);
uint16_t usScibBlockRead(uint16_t *buf, TickType_t xBlockTime);

#endif /* DEVICE_SCI_ABCD_H_ */
