#include "sys_config.h"
#include "spi_device.h"
#include "sysclock_device.h"

void InitSpicGpio(void)
{	
	SysCtl_enablePeripheral(SYSCTL_PERIPH_CLK_SPIC);
	
	GPIO_setPinConfig(mySPI0_SPIPICO_PIN_CONFIG);
	GPIO_setPadConfig(mySPI0_SPIPICO_GPIO, GPIO_PIN_TYPE_STD);
	GPIO_setQualificationMode(mySPI0_SPIPICO_GPIO, GPIO_QUAL_ASYNC);

	GPIO_setPinConfig(mySPI0_SPIPOCI_PIN_CONFIG);
	GPIO_setPadConfig(mySPI0_SPIPOCI_GPIO, GPIO_PIN_TYPE_STD);
	GPIO_setQualificationMode(mySPI0_SPIPOCI_GPIO, GPIO_QUAL_ASYNC);

	GPIO_setPinConfig(mySPI0_SPICLK_PIN_CONFIG);
	GPIO_setPadConfig(mySPI0_SPICLK_GPIO, GPIO_PIN_TYPE_STD);
	GPIO_setQualificationMode(mySPI0_SPICLK_GPIO, GPIO_QUAL_ASYNC);
	
	//GPIO_setPinConfig(mySPI0_SPIPTE_PIN_CONFIG);
	//GPIO_setPadConfig(mySPI0_SPIPTE_GPIO, GPIO_PIN_TYPE_STD);
	//GPIO_setQualificationMode(mySPI0_SPIPTE_GPIO, GPIO_QUAL_ASYNC);

	GPIO_setPadConfig(mySPI0_SPIPTE_GPIO, GPIO_PIN_TYPE_STD);
    GPIO_setDirectionMode(mySPI0_SPIPTE_GPIO, GPIO_DIR_MODE_OUT);
    GPIO_writePin(mySPI0_SPIPTE_GPIO, 1);


}



void vSpicDeviceInit(void)
{    
	InitSpicGpio();
	
    // Initialize SPI FIFO registers
        SpicRegs.SPIFFTX.all=0xE050;                 //16-level
        SpicRegs.SPIFFRX.all=0x2044;
        SpicRegs.SPIFFCT.all=0x0;

	SpicRegs.SPICCR.all =0x0027;	             // Reset on, rising edge, 16-bit char bits
	SpicRegs.SPICTL.all =0x000E;    		     // Enable master mode, normal phase,
                                                 // enable talk, and SPI int disabled.
	SpicRegs.SPIBRR.all =0x0003;				 // SPI Baud Rate 0~3:LSPCLK/4
    SpicRegs.SPICCR.bit.SPISWRESET =1;		         // Relinquish SPI from Reset
//    SpicRegs.SPIPRI.bit.FREE = 1;                // Set so breakpoints don't disturb xmission

}

void spic_xmit(uint8_t a)
{
    while (SpicRegs.SPIFFTX.bit.TXFFST != 0) {}
    SpicRegs.SPITXBUF=a<<8;
}    

void vSpic_xframe(uint8_t * buf,uint8_t len)
{
    int i;

	GPIO_writePin(mySPI0_SPIPTE_GPIO,0);
    for(i = 0;i < len;i++)
    {
        spic_xmit(buf[i]);
    }
    while (SpicRegs.SPIFFTX.bit.TXFFST != 0) {}
    //r(i = 0;i < 5;i++);//ʱ
    DEVICE_DELAY_US1(6);
	GPIO_writePin(mySPI0_SPIPTE_GPIO,1);
}

//===========================================================================
// End of file.
//===========================================================================
